package com.mso.master;

	import java.io.BufferedReader;
	import java.io.IOException;
	import java.io.InputStream;
	import java.io.InputStreamReader;
	import java.net.HttpURLConnection;
	import java.net.URL;
	import java.util.ArrayList;
	import java.util.HashMap;
	import java.util.List;

	import org.json.JSONObject;
	import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.ProgressDialog;
	import android.content.Context;
	import android.graphics.Color;
	import android.location.Address;
	import android.location.Criteria;
	import android.location.Geocoder;
	import android.location.LocationManager;
	import android.os.AsyncTask;
	import android.os.Bundle;
	import android.util.Log;
	import android.view.InflateException;
	import android.view.LayoutInflater;
	import android.view.View;
	import android.view.ViewGroup;
	import android.widget.Toast;

	import com.google.android.gms.maps.CameraUpdateFactory;
	import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnInfoWindowClickListener;
	import com.google.android.gms.maps.LocationSource.OnLocationChangedListener;
	import com.google.android.gms.maps.MapFragment;
	import com.google.android.gms.maps.model.BitmapDescriptorFactory;
	import com.google.android.gms.maps.model.LatLng;
	import com.google.android.gms.maps.model.Marker;
	import com.google.android.gms.maps.model.MarkerOptions;
	import com.google.android.gms.maps.model.PolylineOptions;
import com.squareup.otto.Subscribe;


	@SuppressLint("ValidFragment")
	public class BusStopOnMapFragment extends MapFragment {

		private static View view;
		GoogleMap mMap = null;
		private Context mContext;
		private OnLocationChangedListener mListener;
		private LocationManager locationManager;
		protected MainActivity activity;
		private android.app.FragmentManager myFragmentManager;
		private MapFragment myMapFragment;
		private DBaccess db;
		private Criteria myCriteria;
		private String provider;
		private Marker locationIcon = null;
		private List<BusStop> busStopList = null;
		ArrayList<LatLng> markerPoints;
		private double lat = 0.0;
		private double lon = 0.0;
		
		LatLng fromPosition;
		LatLng toPosition;
		private boolean locationChanged = false;
		private LatLng mPosition;
		private boolean busStopDrawn = false;
		private String chosenBusStop;


		
		//Empty Constructor
		public BusStopOnMapFragment(){

		}
		
		//Constructor to pass the context argument from parent activity class
		public BusStopOnMapFragment (Context con, List<BusStop> list, LatLng pos){
			this.mContext = con;
			this.busStopList = list;
			this.mPosition = pos;
			
			db = new DBaccess(con);
		}
		
		
		@Override
	    public void onActivityCreated(Bundle savedInstanceState) {
	        super.onActivityCreated(savedInstanceState);

	        activity = (MainActivity)getActivity();
	    }


		//On create method when fragment is created
		@Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);	    
	    }
		
		
		//On create view method for fragment
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			super.onCreateView( inflater, container, savedInstanceState );
			
//	        View v = inflater.inflate(R.layout.plannerfragment, container, false);
			
			//Gets the underlying view and saves its state 
			//when moving between Fragment the map is still intact and not changed
		    if (view != null) {
		        ViewGroup parent = (ViewGroup) view.getParent();
		        if (parent != null)
		            parent.removeView(view);

		    }
		    try {
		        view = inflater.inflate(R.layout.busstop_mapfragment, container, false);
		    } catch (InflateException e) {
		        /* map is already there, just return view as it is */
		    }

		    //Receives the underlying map
		 	myFragmentManager = getFragmentManager();
		    myMapFragment = (MapFragment)myFragmentManager.findFragmentById(R.id.busstop_map_fragment);
		    mMap = myMapFragment.getMap();
//		    mMap.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
		    
		    mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(mPosition, 15.0f));

		  //Get Bus Stop list from and draw bus stop markers
		    if(!busStopDrawn){
		    	addBusStops();
		    	busStopDrawn = true;
		    }
		    
		   
		    mMap.setOnInfoWindowClickListener(new OnInfoWindowClickListener(){
		    	@Override
				public void onInfoWindowClick(Marker marker) {
					// TODO Auto-generated method stub
					
					String busstop = marker.getTitle();
					setChosenBusStop(busstop);
					
					List<String> id = db.getBusStopIDbyName(busstop);
					String[] idArray = new String[id.size()];
					id.toArray(idArray);
					
					new FragmentExecuter().execute(idArray);
				
				}
		    });
		
		  
		    return view;
		}
		

	    @Override
	    public void onResume() {
	        super.onResume();
	     // Register ourselves so that we can provide the initial value.
	        LocationChangedHandler.getInstance().register(this);
	    }

	    
	    @Override
	    public void onPause() {
	    	super.onPause();
	    	//Always unregister when an object no longer should be on the bus.
	    	 LocationChangedHandler.getInstance().unregister(this);
	    }

		//Retrieve a bus stop list from the assets POI reader
		public void getBusStopList (){
			busStopList = db.getAllBusStops();
		//	busStopList = poiReader.getBusStopList();
		}
		
		
		//Add Markers for Bus Stops on the map
		public void addBusStops (){
			for (int i = 0; i < busStopList.size(); i++) {
				double lat = Double.parseDouble(busStopList.get(i).getLatitude());
				double lon = Double.parseDouble(busStopList.get(i).getLongitude());
				
				LatLng coordinate = new LatLng(lat, lon);
				String snippet;
				boolean fra = fraSentrum(i);
				if(fra){
					snippet = "Fra Sentrum";
				}
				else{
					snippet = "Til Sentrum";
				}
				
				 locationIcon = mMap.addMarker(new MarkerOptions()
			        .position(coordinate)
			        .title(busStopList.get(i).getName())
//			        .snippet(snippet)
			        .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus_stop_icon_green_scaled)));
			}
		}
		
		
		 @Subscribe public void onLocationChanged(LocationChangedEvent event) {
//			 Avoid duplication icon
			 if(locationChanged){
			 locationIcon.remove();
			 }
			 
			 System.out.println("mapfragmentGet");
			 System.out.println(event.lat);
			 System.out.println(event.lon);
		 
			 setLat(event.lat);
			 setLon(event.lon);
		
			 LatLng coordinate = new LatLng(getLat(), getLon());

			 
			//Add a marker to the current location as a marker overlay
	       locationIcon = mMap.addMarker(new MarkerOptions()
	       .position(coordinate)
	       .anchor((float) 0.5, (float)0.5)
	       .title("Du er her")
	       .snippet(" ")
	       .icon(BitmapDescriptorFactory.fromResource(R.drawable.walking_person2)));
	       
	       locationChanged = true;
			  }

		
		 public boolean fraSentrum (int i){
			 String name = busStopList.get(i).getName();
			 if(i<busStopList.size()-1){
				 String name2 = busStopList.get(i+1).getName();
				 if(name.equals(name2)){
					 return true;
				 }
			 }
			 return false;
		 }

		public double getLat() {
			return lat;
		}


		public void setLat(double lat) {
			this.lat = lat;
		}


		public double getLon() {
			return lon;
		}


		public void setLon(double lon) {
			this.lon = lon;
		}

		
		public void setChosenBusStop(String name){
			this.chosenBusStop = name;
		}
		
		public String getChosenBusStop(){
			return chosenBusStop;
		}
		
		
	
		private String getDirectionsUrl(LatLng origin,LatLng dest){
			
			// Origin of route
			String str_origin = "origin="+origin.latitude+","+origin.longitude;
			
			// Destination of route
			String str_dest = "destination="+dest.latitude+","+dest.longitude;		
			
						
			// Sensor enabled
			String sensor = "sensor=false";			
						
			// Building the parameters to the web service
			String parameters = str_origin+"&"+str_dest+"&"+sensor;
						
			// Output format
			String output = "json";
			
			// Building the url to the web service
			String url = "https://maps.googleapis.com/maps/api/directions/"+output+"?"+parameters;
			
			
			return url;
		}
		
		/** A method to download json data from url */
	    private String downloadUrl(String strUrl) throws IOException{
	        String data = "";
	        InputStream iStream = null;
	        HttpURLConnection urlConnection = null;
	        try{
	                URL url = new URL(strUrl);

	                // Creating an http connection to communicate with url 
	                urlConnection = (HttpURLConnection) url.openConnection();

	                // Connecting to url 
	                urlConnection.connect();

	                // Reading data from url 
	                iStream = urlConnection.getInputStream();

	                BufferedReader br = new BufferedReader(new InputStreamReader(iStream));

	                StringBuffer sb  = new StringBuffer();

	                String line = "";
	                while( ( line = br.readLine())  != null){
	                        sb.append(line);
	                }
	                
	                data = sb.toString();

	                br.close();

	        }catch(Exception e){
	                Log.d("Exception while downloading url", e.toString());
	        }finally{
	                iStream.close();
	                urlConnection.disconnect();
	        }
	        return data;
	     }

		
		
		// Fetches data from url passed
		private class DownloadTask extends AsyncTask<String, Void, String>{			
					
			// Downloading data in non-ui thread
			@Override
			protected String doInBackground(String... url) {
					
				// For storing data from web service
				String data = "";
						
				try{
					// Fetching the data from web service
					data = downloadUrl(url[0]);
				}catch(Exception e){
					Log.d("Background Task",e.toString());
				}
				return data;		
			}
			
			// Executes in UI thread, after the execution of
			// doInBackground()
			@Override
			protected void onPostExecute(String result) {			
				super.onPostExecute(result);			
				
				ParserTask parserTask = new ParserTask();
				
				// Invokes the thread for parsing the JSON data
				parserTask.execute(result);
					
			}		
		}
		
		/** A class to parse the Google Places in JSON format */
	    private class ParserTask extends AsyncTask<String, Integer, List<List<HashMap<String,String>>> >{
	    	
	    	// Parsing the data in non-ui thread    	
			@Override
			protected List<List<HashMap<String, String>>> doInBackground(String... jsonData) {
				
				JSONObject jObject;	
				List<List<HashMap<String, String>>> routes = null;			           
	            
	            try{
	            	jObject = new JSONObject(jsonData[0]);
	            	DirectionsJSONParser parser = new DirectionsJSONParser();
	            	
	            	// Starts parsing data
	            	routes = parser.parse(jObject);    
	            }catch(Exception e){
	            	e.printStackTrace();
	            }
	            return routes;
			}
			
			// Executes in UI thread, after the parsing process
			@Override
			protected void onPostExecute(List<List<HashMap<String, String>>> result) {
				ArrayList<LatLng> points = null;
				PolylineOptions lineOptions = new PolylineOptions();
				MarkerOptions markerOptions = new MarkerOptions();
				
				// Traversing through all the routes
				for(int i=0;i<result.size();i++){
					points = new ArrayList<LatLng>();
					lineOptions = new PolylineOptions();
					
					// Fetching i-th route
					List<HashMap<String, String>> path = result.get(i);
					
					// Fetching all the points in i-th route
					for(int j=0;j<path.size();j++){
						HashMap<String,String> point = path.get(j);					
						
						double lat = Double.parseDouble(point.get("lat"));
						double lng = Double.parseDouble(point.get("lng"));
						LatLng position = new LatLng(lat, lng);	
						
						points.add(position);						
					}
					
					// Adding all the points in the route to LineOptions
					lineOptions.addAll(points);
					lineOptions.width(2);
					lineOptions.color(Color.RED);	
					
				}
				
				// Drawing polyline in the Google Map for the i-th route
				mMap.addPolyline(lineOptions);							
			}			
	    }   
		
	    
	    
	  
		// An AsyncTask class for accessing the GeoCoding Web Service
	    private class GeocoderTask extends AsyncTask<String, Void, List<Address>>{
	 
	    	
	        @Override
	        protected List<Address> doInBackground(String... locationName) {
	            // Creating an instance of Geocoder class
	            Geocoder geocoder = new Geocoder(mContext);
	            List<Address> addresses = null;
	 
	          
	            try {
	                // Getting a maximum of 3 Address that matches the input text
	                addresses = geocoder.getFromLocationName(locationName[0], 3);
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	            return addresses;
	        }
	 
	        
	        
	        @Override
	        protected void onPostExecute(List<Address> addresses) {
	 
	            if(addresses==null || addresses.size()==0){
	                Toast.makeText(mContext, "No Location found", Toast.LENGTH_SHORT).show();
	            }
	 
	            // Clears all the existing markers on the map
//	            mMap.clear();
	 
	            // Adding Markers on Google Map for each matching address
	            for(int i=0;i<addresses.size();i++){
	 
	                Address address = addresses.get(i);
	 
	                // Creating an instance of GeoPoint, to display in Google Map
	                LatLng latlng = new LatLng(address.getLatitude(), address.getLongitude());
	 
	                String addressText = String.format("%s, %s",
	                address.getMaxAddressLineIndex() > 0 ? address.getAddressLine(0) : "",
	                address.getCountryName());
	 
	                MarkerOptions markerOptions = new MarkerOptions();
	                markerOptions.position(latlng);
	                markerOptions.title(addressText);
	                markerOptions.icon(BitmapDescriptorFactory.fromResource(R.drawable.bus_drive_icon));
	 
	                mMap.addMarker(markerOptions);
	 
	                // Locate the first location
	                if(i==0)
	                    mMap.animateCamera(CameraUpdateFactory.newLatLng(latlng));
	            }
	        }
	    }
		
	    
	    
	    
	    // An AsyncTask class for accessing ..
	    private class FragmentExecuter extends AsyncTask<String, Void, String>{
	    	
	    	ProgressDialog mProgressDialog = new ProgressDialog(mContext);
	    	
	    	
	    	 @Override
	         protected void onPreExecute() {
	    		 
	         }
	    	
	    	@Override
			protected String doInBackground(String... fragment) {
	        	
	    			// Create new bus stop map fragment and transaction
					Fragment newFragment = new RealtimeByStopFragment(mContext, fragment, getChosenBusStop());
					android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
					transaction.setCustomAnimations(android.R.animator.fade_in,
	                        android.R.animator.fade_out);

					// Replace whatever is in the fragment_container view with this fragment,
					// and add the transaction to the back stack
					transaction.replace(R.id.fragment_container, newFragment, "busmap");
					transaction.addToBackStack("busmap");
					
					if(newFragment.isHidden()){
						transaction.show(newFragment);
					}
						// Commit the transaction
						transaction.commit();
						
						return "finished";
	        }
	        
	      
	    	@Override
	        protected void onPostExecute(String prog) {
//	    		progressDialog.dismiss();
	        }

		
	    }


		
	}
