package com.mso.master;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;


import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.squareup.otto.Subscribe;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.ProgressDialog;
import android.content.Context;
import android.location.Address;
import android.location.Geocoder;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.InflateException;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;


@SuppressLint("ValidFragment")
public class CloseBusStopFragment extends Fragment{

	private View view;
	private TextView textView;
	private Context mContext;
	private DBaccess db;
	private ProgressDialog progressDialog;
//	private ProgressBarAsync mProgressbarAsync;
	private MainActivity activity;
	
	private String distance;
	private List<String> distances;
	private List<BusStop> busStopList;
	private List<BusStop> busStopListReduced;
	private LatLng myPosition = null;
//	private ProgressDialog progressdialog;
	private ArrayList<DistanceBusStops> distanceList;

	
	private ListView listView;
	
	LatLng fromDestinationCoordinate;
	LatLng toDestinationCoordinate;
	
	private ArrayAdapter<DistanceBusStops> adapter;
	private String chosenBusStop;


	public CloseBusStopFragment(Context con, List<BusStop> busstops, LatLng pos){
		this.mContext = con;
	
		this. busStopList = busstops;
		this.distances = new ArrayList<String>();
//		this.distanceList = new ArrayList<DistanceBusStops>();
		this.myPosition = pos;
		
		db = new DBaccess(con);
	}
	
	
		@Override
		 public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			super.onCreateView( inflater, container, savedInstanceState );
			//View view = inflater.inflate(R.layout.closebusstops, container, false);
			//JourneyPlannerFragment.progressDialog.dismiss();
			
			//Gets the underlying view and saves its state 
			//when moving between Fragment the map is still intact and not changed
		    if (view != null) {
		        ViewGroup parent = (ViewGroup) view.getParent();
		        if (parent != null)
		            parent.removeView(view);

		    }
		    try {
		        view = inflater.inflate(R.layout.closebusstops, container, false);
		    } catch (InflateException e) {
		        /* map is already there, just return view as it is */
		    }

	        view.setBackgroundColor(getResources().getColor(R.color.black));
			  
	        distanceList = new ArrayList<DistanceBusStops>();
	        
	       //start the progress dialog
			progressDialog = ProgressDialog.show(mContext, "", "Laster inn busstopper nr deg...");
			 
			
	        textView = (TextView) view.findViewById(R.id.textView_closestops);
	        textView.setTextColor(getResources().getColor(R.color.white));
	        
			busStopListReduced = removeDuplicates(busStopList);

	      
			listView = (ListView) view.findViewById(R.id.listview_closebusstops);
				
			 
			AlterAdapter();   
			
			listView.setOnItemClickListener(new OnItemClickListener() {
				
				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					// TODO Auto-generated method stub
					
					//start the progress dialog
					progressDialog = ProgressDialog.show(mContext, "", "Laster inn sanntidsdata...");
					
					String busStopname = listView.getAdapter().getItem(arg2).toString();
					System.out.println(busStopname);
					
					String name = "";
					for (int i = 0; i < busStopname.length()-7; i++){
					    char c = busStopname.charAt(i);   
					    name += c;
					    if(busStopname.charAt(i+1) == ' ' && busStopname.charAt(i+2) == ' '){
					    	break;
					    }
					    
					    System.out.println(name);
					}
					
					System.out.println(name);
					setChosenBusStop(name);
					
					List<String> id = db.getBusStopIDbyName(name);
					System.out.println(id.toString());
					String[] idArray = new String[id.size()];
					id.toArray(idArray);
					
					new FragmentExecuter().execute(idArray);
				}
			});
			
			

			return view;
		}
	


		  @Override
		    public void onResume() {
		        super.onResume();
		     // Register ourselves so that we can provide the initial value.
		        LocationChangedHandler.getInstance().register(this);
		    }

		    
		    @Override
		    public void onPause() {
		    	super.onPause();
		    	
		    	//Always unregister when an object no longer should be on the bus.
		    	 LocationChangedHandler.getInstance().unregister(this);
		    }
		

		    // Filters list of contacts based on user search criteria. If no information is filled in, contact list will be blank.
		    private void AlterAdapter() {
		    	
//		    	System.out.println("distlistsize" +  distanceList.size());
		        if (distanceList.isEmpty()) {
//		        	distanceList.clear();
//		            adapter.notifyDataSetChanged();
//		        }
//		        else {
//		        	distanceList.clear();
//		            
		        	System.out.println(getMyPosition());
		        	
		        	new GeocoderDistanceTask().execute(getMyPosition());	
//		            adapter.notifyDataSetChanged();
		           
		        }
		    }
		    
		    
		    @Subscribe public void onLocationChanged(LocationChangedEvent event) {

				 LatLng coordinate = new LatLng(event.lat, event.lon);
				 setMyPosition(coordinate);

		    }    
		    
		    
		public String getDistance() {
			return distance;
		}

		public void setDistance(String distance) {
			this.distance = distance;
		}

		public double maxLatitudeDistance (){
			return 63.4307 - 63.4278;
		}
		
		public double maxLongitudeDistance(){
			return 10.3927 - 10.3859;
		}
		
		
		public void setChosenBusStop(String name){
			this.chosenBusStop = name;
		}
		
		public String getChosenBusStop(){
			return chosenBusStop;
		}

	
		public List<BusStop> removeDuplicates (List<BusStop> stops){
			List<BusStop> res = new ArrayList<BusStop>();
			for (int i = 0; i < busStopList.size()-1; i++) {
				if(!busStopList.get(i).getName().equals(busStopList.get(i+1).getName())){
					res.add(busStopList.get(i));
				}
				if(i==busStopList.size()-2){
					res.add(busStopList.get(i));
				}
			}
			
			return res;
		}
		
		
		// An AsyncTask class for accessing the GeoCoding Web Service
	    private class GeocoderDistanceTask extends AsyncTask<LatLng, Void, String>{

	        @Override
	        protected String doInBackground(LatLng... locations) {
	            
	        	LatLng start = locations[0];
//	        	LatLng end = locations[1];
	        	DistanceBusStops object = null;
	        	
	        	GeoDistance getDistance = new GeoDistance();
	        	
	        	if(start!=null){
				    for (int i = 0; i < busStopListReduced.size(); i++) {
				    	if(Math.abs((start.latitude - Double.parseDouble(busStopListReduced.get(i).getLatitude()))) < maxLatitudeDistance()  &&  Math.abs((start.longitude - Double.parseDouble(busStopListReduced.get(i).getLongitude()))) < maxLongitudeDistance()){
				    		LatLng end = new LatLng(Double.parseDouble(busStopListReduced.get(i).getLatitude()), Double.parseDouble(busStopListReduced.get(i).getLongitude()));
					   		String distance = getDistance.GetRoutDistane(start.latitude, start.longitude, end.latitude, end.longitude, "driving");
					   		
					   		System.out.println(distance);
					   		System.out.println(busStopListReduced.get(i).getLocationId());
					   	
					   		object = new DistanceBusStops(busStopListReduced.get(i).getName(), busStopListReduced.get(i).getLocationId(), distance);
					   		distanceList.add(object);
				    	}
				    }
				}
	      
	        	Collections.sort(distanceList, new CustomComparator());
	        	
	            return "finished";
	        }
	 
	        
	        @Override
	        protected void onPostExecute(String params) {
//	        	setDistance(distance);
	        	System.out.println(params);
//	            distances.add(distance);
	        	
//	        	adapter.notifyDataSetChanged();
	        	
	        	CustomBusStopAdapter adapter = new CustomBusStopAdapter(mContext, R.layout.row_busstops, distanceList);
//				adapter = new ArrayAdapter<DistanceBusStops>(mContext, R.layout.row, distanceList);
			        listView.setAdapter(adapter);
	        	
	        	progressDialog.dismiss();
	            
	        }
	    }


		public LatLng getMyPosition() {
			return myPosition;
		}


		public void setMyPosition(LatLng myPosition) {
			this.myPosition = myPosition;
		}


	 
		public class CustomComparator implements Comparator<DistanceBusStops> {
		    @Override
		    public int compare(DistanceBusStops o1, DistanceBusStops o2) {
		        return o1.getDistance().compareTo(o2.getDistance());
		    }
		}
		

		 // An AsyncTask class for accessing ..
	    private class FragmentExecuter extends AsyncTask<String, Void, String>{
	    	
	    	ProgressDialog mProgressDialog = new ProgressDialog(mContext);
	    	
	    	
	    	 @Override
	         protected void onPreExecute() {
	    		 
	         }
	    	
	    	@Override
			protected String doInBackground(String... fragment) {
	        	
	    			// Create new bus stop map fragment and transaction
					Fragment newFragment = new RealtimeByStopFragment(mContext, fragment, getChosenBusStop());
					android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
					transaction.setCustomAnimations(android.R.animator.fade_in,
	                        android.R.animator.fade_out);

					// Replace whatever is in the fragment_container view with this fragment,
					// and add the transaction to the back stack
					transaction.replace(R.id.fragment_container, newFragment);
					transaction.addToBackStack(null);
					
					if(newFragment.isHidden()){
						transaction.show(newFragment);
					}
						// Commit the transaction
						transaction.commit();
						
						return "finished";
	        }
	        
	      
	    	@Override
	        protected void onPostExecute(String prog) {
	    		progressDialog.dismiss();
	        }

		
	    }
	
}
