package com.mso.master;

import java.awt.font.TextAttribute;
import java.text.AttributedString;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;


public class CustomRealTimeAdapter extends ArrayAdapter<RealtimeByBusStop> {

   private ArrayList<RealtimeByBusStop> objects;

   public CustomRealTimeAdapter(Context context, int textViewResourceId, ArrayList<RealtimeByBusStop> objects) {
        super(context, textViewResourceId, objects);
        this.objects = objects;
}

  @Override
  public View getView(int position, View convertView, ViewGroup parent) {

  View v = convertView;
  if (v == null) {
        LayoutInflater inflater = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        v = inflater.inflate(R.layout.row_realtime, null);
    }

   
  RealtimeByBusStop i = objects.get(position);

	if (i != null) {
	    TextView routeView = (TextView) v.findViewById(R.id.column1_route);
	    TextView directionView = (TextView) v.findViewById(R.id.center_direction);
	    TextView departureView = (TextView) v.findViewById(R.id.column2_departure);
	
	    if (routeView != null){
	    	routeView.setText("  " + i.getLine());
	    }
	    if (directionView != null){
	    	directionView.setText(i.getDestination());
	    }
	    if (departureView != null){
	    	departureView.setText(printDepartureTime(i));
	    }
	
	}

return v;
  }
  
  public String getDepartureTime(String s){
	  String res;
	  res = s.substring(11, 16);
	  return res;
  }
  
  public String getDateOfDeparture(String s){
	  String res;
	  res = s.substring(8, 9) + "/" + s.substring(5, 6);
	  return res;
  }
  
  public boolean isDelayed (String reg, String sched){
	  int hour1 = Integer.parseInt(reg.substring(0, 1));
	  int hour2 = Integer.parseInt(sched.substring(0, 1));
	  int min1 = Integer.parseInt(reg.substring(3, 4));
	  int min2 = Integer.parseInt(sched.substring(3, 4));

	  if(hour1 > hour2 ){
		  return true;
	  }
	  if(hour1 == hour2 && min1 > min2){
		  return true;
	  }
	  return false;
  }
  
  
  public String printDepartureTime(RealtimeByBusStop object){
	  String departureTime = getDepartureTime(object.getRegisteredDepartureTime());
	  String scheduledDepTime = getDepartureTime(object.getScheduledDepartureTime());
	  boolean delayed = isDelayed(departureTime, scheduledDepTime);
	  
	  String res;
	  
	  if(!object.isRealtimeData()){
		  res = "ca. " + scheduledDepTime + "  ";
		  return res;
	  }
	  if(delayed){
		  res = departureTime + "  " + "(" + scheduledDepTime +")  ";
		
//		  AttributedString as = new AttributedString(res);
//		  as.addAttribute(TextAttribute.STRIKETHROUGH,
//			        TextAttribute.STRIKETHROUGH_ON, 7, 11);
		  return res;
	  }
	  return departureTime + "  ";
  }

  
  
} 