package com.mso.master;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import com.google.android.gms.maps.model.LatLng;
import com.mso.master.RealTimeFragment.HttpTaskHandler;
import com.squareup.otto.Produce;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.os.AsyncTask;
import android.util.Log;

public class DBaccess {

	private  Context mContext;

	// Database fields
	private SQLiteDatabase database;
	
	private DataManipulator dm;
	private List<BusStop> busStopList;

	public DBaccess (Context c){
		this.mContext = c;
		this.dm = new DataManipulator(mContext);

	}
	
	
		public void insertBusStopObjectInDB(BusStop busstop){
			insertBusStopinDB(busstop.getName(), busstop.getNameWithAbbreviations(), busstop.getLocationId(), busstop.getLatitude(), busstop.getLongitude());
		}
	
	  public List<String> getAllBusStopNames(){
		  List<String> list = dm.selectBusStopNames();
		  return list;
	  }
	  
	  
	  public void addPolyline(LatLng poly, String route){
		  dm.insertPolylines(String.valueOf(poly.latitude), String.valueOf(poly.longitude), route);
	  }
	
	  public List<LatLng> getPolylines(String route){
		  List<LatLng> points = dm.selectPolylines(route);
		  return points;
	  }
	  
	  public List<BusStop> getAllBusStops(){
		  return dm.selectAllBusStops();  
	  }
	  
	  public List<String> getBusStopIDbyName(String name){
		  return dm.selectBusStopIDbyName(name);
	  }
	  
	  
	  public void insertBusStopinDB(String name, String abbname, String locid, String latitude, String longitude){
		  dm.insertBusStops(name, abbname, locid, latitude, longitude);
	  }
	  
	  public List<String> getBusStopNameById(String id){
		  return dm.selectBusStopNameById(id);
	  }
	  
	  public List<DistanceBusStops> getAllDistanceBusStops(){
		  return dm.selectAllDistances();
	  }
	  
	  public List<String> getDistanceByID(String id){
		  return dm.selectDistanceById(id);
	  }
	  public void deleteDistanceEntriesInDB(){
		  dm.deleteDistanceTable();
	  }
	  public void insertDistancesInDB(String name, String distance, String locid, String loc){
		  dm.insertDistance(name, distance, locid, loc);
	  }
	  public List<DistanceBusStops> getDistanceListByLoc(String loc){
		  return dm.selectDistanceObjectByLoc(loc);
	  }
	  public List<String> getAllBusStopIDfromDistanceTable(String loc){
		  return dm.selectAllBusStopIdForDistanceTable(loc);
	  }
	  public List<DistanceBusStops> getDistanceObjectByLocID(String locid){
		  return dm.selectDistanceObjectByLocID(locid);
	  }
	  public LatLng getBusStopLocById(String id){
		  return dm.selectBusStopLocById(id);
	  }
	  public String getBusStopLocidByLocation(LatLng location){
		  return dm.selectBusStopLocidByLocation(location);
	  }
	  public String checkIfDistanceTableHoldBusStopID(String locid){
		  return dm.checkIfDistanceTableHoldBusStopID(locid);
	  }
	  
	public boolean doesDatabaseExist() {
	  File dbFile = new File("/data/data/com.mso.master/databases/publictransport.db");
	  return dbFile.exists();
	}
	
	public boolean distanceTableHoldsValues(){
		List<DistanceBusStops> list = dm.selectAllDistances();
		if(list.size()>0){
			return true;
		}
		return false;
	}

	
}
