package com.mso.master;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.Context;
import android.graphics.Color;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.format.Time;
import android.util.Log;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.LocationSource.OnLocationChangedListener;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;
import com.mso.master.CloseBusStopFragment.CustomComparator;
import com.mso.master.RealtimeByStopFragment.HttpTask;
import com.mso.master.RealtimeByStopFragment.HttpTaskHandler;
import com.squareup.otto.Subscribe;


@SuppressLint("ValidFragment")
public class JourneyMapFragment extends MapFragment {

	private static View view;
	GoogleMap mMap = null;
	private Context mContext;
	protected MainActivity activity;
	
	private android.app.FragmentManager myFragmentManager;
	private MapFragment myMapFragment;
	private DBaccess db;
	
	private Criteria myCriteria;
	private String provider;
	
	private Marker locationIcon = null;
	private Marker busStopFrom = null;
	private Marker busStopTo = null;
	private Marker endLocation = null;
	private Marker startLocation = null;
	
	private List<BusStop> busStopList = null;
	private List<DistanceBusStops> distanceListFromDest;
	private List<DistanceBusStops> distanceListToDest;
	private ArrayList<SchedulesByBusStop> schedulesByStopListFromDest;
	private ArrayList<PossibleRoute> possibleRouteList;
	private List<PolylineOptions> polyLineOptionsList;
	private List<LatLng> polylineList;
	private List<Polyline> polyLineList;
	private List<Trip> tripsList;
	private ArrayList<LatLng> markerPoints;
	private List<Stops> finalStopsList;

	private double lat = 0.0;
	private double lon = 0.0;
	
	private final double WALKING_SPEED = 5.0;
	private final double MINUTES_IN_HOUR = 60.0;
	
	LatLng fromPosition;
	LatLng toPosition;
	LatLng myPosition;
	private boolean locationChanged = false;

	private ProgressDialog progressDialog;
	
	private String time;

	
	//Empty Constructor
	public JourneyMapFragment(){

	}
	
	//Constructor to pass the context argument from parent activity class
	public JourneyMapFragment (Context con, LatLng from, LatLng to, LatLng pos){
		this.mContext = con;
		this.fromPosition = from;
		this.toPosition = to;
		
		setMyPosition(pos);

		db = new DBaccess(con);
		distanceListFromDest = new ArrayList<DistanceBusStops>();
		distanceListToDest = new ArrayList<DistanceBusStops>();
		schedulesByStopListFromDest = new ArrayList<SchedulesByBusStop>();
		possibleRouteList = new ArrayList<PossibleRoute>();
		finalStopsList = new  ArrayList<Stops>();
		polyLineOptionsList = new ArrayList<PolylineOptions>();
		polylineList = new ArrayList<LatLng>();
		polyLineList = new ArrayList<Polyline>();
		tripsList = new ArrayList<Trip>();
	}
	
	@Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        activity = (MainActivity)getActivity();
    }

	//On create method when fragment is created
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);	    
    }
	
	//On create view method for fragment
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		super.onCreateView( inflater, container, savedInstanceState );
		//Gets the underlying view and saves its state 
		//when moving between Fragment the map is still intact and not changed
	    if (view != null) {
	        ViewGroup parent = (ViewGroup) view.getParent();
	        if (parent != null)
	            parent.removeView(view);
	    }
	    try {
	        view = inflater.inflate(R.layout.planner_mapfragment, container, false);
	    } catch (InflateException e) {
	        /* map is already there, just return view as it is */
	    }
	    
	    //Receives the underlying map
	 	myFragmentManager = getFragmentManager();
	    myMapFragment = (MapFragment)myFragmentManager.findFragmentById(R.id.planner_map_fragment);
	    mMap = myMapFragment.getMap();
	
	    
	    //CHANGE THIS!!!!!!!!
	    mMap.clear();
	    

	  //Center map around the location icon and zoom in at given zoom level
	  	mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(getFromPosition(), 14.0f));

	    
        //Get Bus Stop list from assets file and draw bus stop markers
	    if(busStopList==null){
	    	getBusStopList();
	    	addBusStops();
	    }
	    
	 	//Get distances to bus stops close to start and end location
	 	String[] array = {"from","to"};
	 
	 	//start the progress dialog
		progressDialog = ProgressDialog.show(mContext, "", "Beregner beste reiserute...");
		new BusStopsDistanceTask().execute(array);

	    return view;
	}
	

    @Override
    public void onResume() {
        super.onResume();
     // Register ourselves so that we can provide the initial value.
        LocationChangedHandler.getInstance().register(this);
    }

    
    @Override
    public void onPause() {
    	super.onPause();
    	//Always unregister when an object no longer should be on the bus.
    	 LocationChangedHandler.getInstance().unregister(this);
    }

	//Retrieve a bus stop list from the assets POI reader
	public void getBusStopList (){
		busStopList = db.getAllBusStops();
	}
	
	public String getTimeRightNow(){
		Time today = new Time(Time.getCurrentTimezone());
		today.setToNow();
		int minute = today.minute;
		String min = String.valueOf(minute);
		if(min.length()==1){
			String time = today.hour+":"+"0"+today.minute;
			return time;
		}
		else{
		String time = today.hour+":"+today.minute;
		return time;
		}
	}

	public boolean TimeIsPassed(String t1, String t2){
//		String t1 = getTimeRightNow();
		System.out.println("\n time is passed? " + t1 + " by "+t2);
		 
		  int hour1 = Integer.parseInt(t1.substring(0, 2));
		  int hour2 = Integer.parseInt(t2.substring(0, 2));
		  int min1 = Integer.parseInt(t1.substring(3, 5));
		  int min2 = Integer.parseInt(t2.substring(3, 5));

		  if(hour1 > hour2 ){
			  return true;
		  }
		  if(hour1 == hour2 && min1 > min2){
			  return true;
		  }
		  return false;
	}
	
	
	public int getTimeUntilBusDeparts(String timeRightNow, String depTime){
		  int hour1 = Integer.parseInt(timeRightNow.substring(0, 2));
		  int hour2 = Integer.parseInt(depTime.substring(0, 2));
		  int min1 = Integer.parseInt(timeRightNow.substring(3, 5));
		  int min2 = Integer.parseInt(depTime.substring(3, 5));

		  
		  if(hour1 == hour2 ){
			  System.out.println("min calculations");
			  System.out.println(depTime);
			  System.out.println(min2);
			  System.out.println(min1);
			  System.out.println(min2-min1);
			  return min2-min1;
		  }
		  else if(hour1 < hour2){
			  int addMin = (hour2-hour1)*60;
			  
			  return (min2-min1)+addMin;
		  }
		  return 0;
	}
	
	//Add Markers for Bus Stops on the map
		public void addBusStops (){
			for (int i = 0; i < busStopList.size(); i++) {
				double lat = Double.parseDouble(busStopList.get(i).getLatitude());
				double lon = Double.parseDouble(busStopList.get(i).getLongitude());
				
				LatLng coordinate = new LatLng(lat, lon);
				locationIcon = mMap.addMarker(new MarkerOptions()
			        .position(coordinate)
			        .title(busStopList.get(i).getName())
			        .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus_stop_icon_green_scaled)));
			}
		}
	
	
	 @Subscribe public void onLocationChanged(LocationChangedEvent event) {
		 //Avoid duplication icon
		 if(locationChanged){
		 locationIcon.remove();
		 }
		 setLat(event.lat);
		 setLon(event.lon);
	
		 LatLng coordinate = new LatLng(getLat(), getLon());
//		 mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(coordinate, 15.0f));

		//Add a marker to the current location as a marker overlay
       locationIcon = mMap.addMarker(new MarkerOptions()
       .position(coordinate)
       .anchor((float) 0.5, (float)0.5)
       .title("Du str her")
      
       .icon(BitmapDescriptorFactory.fromResource(R.drawable.walking_person2)));
       
       locationChanged = true;
	}

	 
	 public void tripPlanner (){
		 List<URI> uriList = new ArrayList<URI>();
		 
		 //Get all bus stop ID's 
		 List<String> busStopIdFrom = db.getAllBusStopIDfromDistanceTable("from");

		    for (int j = 0; j < busStopIdFrom.size(); j++) {
				try {
					uriList.add(new URI("http://bartebuss.no/api/unified/"+busStopIdFrom.get(j)));
				} catch (URISyntaxException e) {
					e.printStackTrace();
					System.out.println("could not instansiate url");
				}
		       } 
		 URI[] uri = new URI[busStopIdFrom.size()];
		 uriList.toArray(uri);
		 
		 //Get schedules for all bus stops close to departure location
		 new ScheduleTimeTask().execute(uri);
	 }

	 
	 public boolean doesTripContainStop(String startBusStopId, String endBusStopId, Trip trip){
				 List<Stops> stopList = trip.getStops();
				 String startId = null;
				 
				 for (int k = 0; k < stopList.size(); k++) {
					if(stopList.get(k).getBusstopID().equals(startBusStopId)){
						startId = startBusStopId;
					}
					else if(stopList.get(k).getBusstopID().equals(endBusStopId) && startId == null){
						return false;
					}
					else if(stopList.get(k).getBusstopID().equals(endBusStopId) && startId != null){
						return true;
					}
				}
				 return false;
		 }
		 
	 
	 public PossibleRoute getBestPossibleRoute(){
		
		 //Calculate value factor for distance walking time from departure to bus stop
		 for (int i = 0; i < possibleRouteList.size(); i++) {

					List<Stops> stopsList = possibleRouteList.get(i).getTrips().getStops();
					
					//Iterate through the stop list
					for (int k = 0; k < stopsList.size(); k++) {
						
						if(stopsList.get(k).getBusstopID().equals(possibleRouteList.get(i).getEndBusStopId())){

//							//Set wait time at bus stop for bus to arrive
//							double totaltime = CompareTimeStrings(getTimeRightNow(), stopsList.get(k).getDepartureTimeFromStart());
//							double wait_time = totaltime - possibleRouteList.get(i).getW1(); 
//							possibleRouteList.get(i).setWait_time(wait_time);
							
							//Set travel time with bus
							double time = CompareTimeStrings(stopsList.get(k).getDepartureTimeFromStart(), stopsList.get(k).getTime());
							possibleRouteList.get(i).setW2(time);
							possibleRouteList.get(i).setDestinationTimeAtBusStop(stopsList.get(k).getTime());
						}
					}
					
					List<DistanceBusStops> distObjTo = db.getDistanceObjectByLocID(possibleRouteList.get(i).getEndBusStopId());
					String endDist = distObjTo.get(0).getDistance();
					String resEndDist = "";

					if(endDist.charAt(0)!='T' && endDist!=null){
						//If value is given in km (e.g. 1.3 km)
						if(endDist.contains(".")){
							for (int l= 0; l < endDist.length()-1; l++) {
								resEndDist+= endDist.charAt(l);
								if(endDist.charAt(l+1) == ' '){
									break;
								}
							}
							
							double endDistValue = Double.parseDouble(resEndDist);
							possibleRouteList.get(i).setW3((endDistValue/WALKING_SPEED)*MINUTES_IN_HOUR);
						}
						//Else if value is given in meter (e.g. 70 m)
						else{
							for (int m= 0; m < endDist.length(); m++) {
								resEndDist+= endDist.charAt(m);
								if(endDist.charAt(m) == ' '){
									break;
								}
							}
							double endDistValue = Double.valueOf(resEndDist);
							double distvalueInKm = endDistValue/100;
							possibleRouteList.get(i).setW3((distvalueInKm/WALKING_SPEED)*MINUTES_IN_HOUR);
						}
					}
//		 		}		
				possibleRouteList.get(i).computeWeightValue();
				possibleRouteList.get(i).computeTotalTime();
		}
		 
		 if(possibleRouteList.size()>0){
		 Collections.sort(possibleRouteList, new CustomTotalTimeComparator());
		 
//		 List<PossibleRoute> list = new ArrayList<PossibleRoute>();
//		 
//		 for (int j = 0; j < possibleRouteList.size()-1; j++) {
//			
//			 if(j==0){
//				 list.add(possibleRouteList.get(j));
//			 }
//			 else if(possibleRouteList.get(j).getTotal_time()- possibleRouteList.get(j+1).getTotal_time() < 2){
//				 list.add(possibleRouteList.get(j+1));
//			 }
//		 }
//
//		 if(list.size()>1){
//			 Collections.sort(possibleRouteList, new CustomWeightComparator());
//			 return list.get(list.size()-1);
//		 }
////		
//		 else{
//			 return possibleRouteList.get(0);
//		 }
			 
		
		 return possibleRouteList.get(0);
		 }
		 else{
			 return null;
		 }
		 
	 }
	 
	 
	 public void drawBestRouteOnMap(PossibleRoute route){

	 	LatLng BusStopFromLoc = db.getBusStopLocById(route.getStartBusStopId());
	 	LatLng BusStopToLoc = db.getBusStopLocById(route.getEndBusStopId());

	 	List<String> busStopFromName = db.getBusStopNameById(route.getStartBusStopId());
	 	String busStopName = busStopFromName.get(0).toString();
	 	
	 	List<String> busStopFromName2 = db.getBusStopNameById(route.getEndBusStopId());
	 	String busStopName2 = busStopFromName2.get(0).toString();
	 	
	 	//Add a markers
	       startLocation = mMap.addMarker(new MarkerOptions()
	       .position(getFromPosition())
	       .anchor((float) 0.5, (float)0.5)
	       .title("Fra denne destinasjonen")
	       .icon(BitmapDescriptorFactory.fromResource(R.drawable.walking_person2)));
	 	
	       endLocation = mMap.addMarker(new MarkerOptions()
	       .position(getToPosition())
	       .anchor((float) 0.5, (float)0.5)
	       .title("G til denne destinasjonen")
	       .icon(BitmapDescriptorFactory.fromResource(R.drawable.walking_person2)));
	 	
	       busStopFrom = mMap.addMarker(new MarkerOptions()
	       .position(BusStopFromLoc)
	       .anchor((float) 0.5, (float)0.5)
	       .title("Ta buss nr: " + route.getLine() + " fra \n" + busStopName)
	       .snippet("Avgang kl: " + route.getDepartureBusTime().substring(11, 16))
	       .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus)));
	 	
	       busStopTo = mMap.addMarker(new MarkerOptions()
	       .position(BusStopToLoc)
	       .anchor((float) 0.5, (float)0.5)
	       .title("G av bussen p " + busStopName2)
	       .snippet("Ankomst: " + route.getDestinationTimeAtBusStop())
	       .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus)));
	 	
	 	
	       for (int j = 0; j < 3; j++) {
			
	    	   if(j==0){
	    		   String url = getDirectionsUrl(getFromPosition(), BusStopFromLoc, "walking");	
	    		   new DownloadTask().execute(url);
	    	   }
	    	   else if(j==1){
	    		   new DrawFinalBusRouteTask().execute(route);
	    	   }
	    	   else if(j==2){
	    		   String url = getDirectionsUrl(BusStopToLoc, getToPosition(), "walking");	
	    		   new DownloadTask().execute(url);
	    	   }
		}
	 }

	 
	 public double CompareTimeStrings(String s1, String s2){
		 
		 String s1mod = null;
		 String s2mod = null;
		 
		 if(s1.length()>11){
			 //String s1 is on the format e.g. "2013-95-15 11:53" and needs to be modified 
			 s1mod = s1.substring(11, 16);
			 s2mod = s2;
		 }
		 else if(s2.length()>11){
			 //String s2 is on the format e.g. "2013-95-15 11:53" and needs to be modified 
			 s2mod = s2.substring(11, 16); 
			 s1mod = s1;
		 }
		 
		 Double hour1 = Double.valueOf(s1mod.substring(0, 2));
		 Double hour2 = Double.valueOf(s2mod.substring(0, 2));
		 Double min1 = Double.valueOf(s1mod.substring(3, 5));
		 Double min2 = Double.valueOf(s2mod.substring(3, 5));
		 
		 if(hour1 == hour2){
			 return min2-min1;
		 }
		 else{
			 Double hourMin = (hour2-hour1)*60;
			 return hourMin+(min2-min1);
		 }
	 }
	 

	public double getLat() {
		return lat;
	}
	public void setLat(double lat) {
		this.lat = lat;
	}
	public double getLon() {
		return lon;
	}
	public void setLon(double lon) {
		this.lon = lon;
	}

	public LatLng getMyPosition(){
		return myPosition;
	}
	
	public void setMyPosition(LatLng pos){
		this.myPosition = pos;
	}
	
	public double maxLatitudeDistance (){
		return 63.4307 - 63.4278;
	}
	
	public double maxLongitudeDistance(){
		return 10.3927 - 10.3859;
	}
	

	
	private String getDirectionsUrl(LatLng origin,LatLng dest, String mode){
		// Origin of route
		String str_origin = "origin="+origin.latitude+","+origin.longitude;
		// Destination of route
		String str_dest = "destination="+dest.latitude+","+dest.longitude;			
		// Sensor enabled
		String sensor = "sensor=true";			
		// Building the parameters to the web service
		String parameters = str_origin+"&"+str_dest+"&"+sensor;
		// Output format
		String output = "json";
		// Building the url to the web service
		String url = "https://maps.googleapis.com/maps/api/directions/"+output+"?"+parameters+"&mode="+mode;
		return url;
	}
	
	/** A method to download json data from url */
    private String downloadUrl(String strUrl) throws IOException{
        String data = "";
        InputStream iStream = null;
        HttpURLConnection urlConnection = null;
        try{
                URL url = new URL(strUrl);
                // Creating an http connection to communicate with url 
                urlConnection = (HttpURLConnection) url.openConnection();
                // Connecting to url 
                urlConnection.connect();
                // Reading data from url 
                iStream = urlConnection.getInputStream();
                BufferedReader br = new BufferedReader(new InputStreamReader(iStream));
                StringBuffer sb  = new StringBuffer();
                String line = "";
                while( ( line = br.readLine())  != null){
                        sb.append(line);
                }
                data = sb.toString();
                br.close();
        }catch(Exception e){
                Log.d("Exception while downloading url", e.toString());
        }finally{
                iStream.close();
                urlConnection.disconnect();
        }
        return data;
     }

	
	// Fetches data from url passed
	private class DownloadTask extends AsyncTask<String, Void, String>{			
		
		@Override
		protected String doInBackground(String... url) {
			// For storing data from web service
			String data = "";
			try{
				//Fetching the data from web service
				data = downloadUrl(url[0]);
			}catch(Exception e){
				Log.d("Background Task",e.toString());
			}
			return data;		
		}
	
		@Override
		protected void onPostExecute(String result) {			
			super.onPostExecute(result);
			ParserWalkingTask parserTask = new ParserWalkingTask();
			// Invokes the thread for parsing the JSON data
			parserTask.execute(result);	
		}		
	}
	

	/** A class to parse the Google Places in JSON format */
    private class ParserWalkingTask extends AsyncTask<String, Integer, String >{
    	    	
    			@Override
    			protected String doInBackground(String... jsonData) {
    				
    				JSONObject jObject;	
    				List<List<HashMap<String, String>>> routes = null;			           
    	            
    	            try{
    	            	jObject = new JSONObject(jsonData[0]);
    	            	DirectionsJSONParser parser = new DirectionsJSONParser();
    	            	
    	            	// Starts parsing data
    	            	routes = parser.parse(jObject);    
    	            }catch(Exception e){
    	            	e.printStackTrace();
    	            }

    				ArrayList<LatLng> points;
    				PolylineOptions lineOptions = new PolylineOptions();
 
    				// Traversing through all the routes
    				for(int i=0;i<routes.size();i++){
    					points = new ArrayList<LatLng>();
    					lineOptions = new PolylineOptions();
    					
    					// Fetching i-th route
    					List<HashMap<String, String>> path = routes.get(i);
    					
    					// Fetching all the points in i-th route
    					for(int j=0;j<path.size();j++){
    						HashMap<String,String> point = path.get(j);					
    						
    						double lat = Double.parseDouble(point.get("lat"));
    						double lng = Double.parseDouble(point.get("lng"));
    						LatLng position = new LatLng(lat, lng);	
    						
    						points.add(position);		
    						polylineList.add(position);
    					}
    					
    					// Adding all the points in the route to LineOptions
    					lineOptions.addAll(points);
    					lineOptions.width(4);
    					lineOptions.color(Color.BLUE);	
    					polyLineOptionsList.add(lineOptions);
    				}
    	            return "finished";
    			}
    			
    			@Override
    			protected void onPostExecute(String result) {

    				// Drawing polyline in the Google Map for the i-th route
    				for (int i = 0; i < polyLineOptionsList.size(); i++) {
    					polyLineList.add(mMap.addPolyline(polyLineOptionsList.get(i)));
    				}
    				System.out.println("polylines drawn upon map");
//    				progressDialogPopup.dismiss();
    			}	
    			
    			 	
    	    }   
	
  
	
    /******************
     * Async class to recieve distances between two locations
    **************************************************************** */
    private class BusStopsDistanceTask extends AsyncTask<String, Void, String>{
        @Override
        protected String doInBackground(String... locations) {
            
        	//If there is already distance values (old) in DB - delete these
        	if(db.distanceTableHoldsValues()){
        		System.out.println("Distance table holds values - Deleting values");
        		db.deleteDistanceEntriesInDB();
        	}
        	else{
        		System.out.println("Distance Table in DB is empty");
        	}
        	
        	DistanceBusStops object = null;
        	GeoDistance getDistance = new GeoDistance();

        			//Gets distances for the "from" location - departure location
        			if(locations[0].equals("from")){
    				    for (int i = 0; i < busStopList.size(); i++) {
    				    	if(Math.abs((getFromPosition().latitude - Double.parseDouble(busStopList.get(i).getLatitude()))) < maxLatitudeDistance()  &&  Math.abs((getFromPosition().longitude - Double.parseDouble(busStopList.get(i).getLongitude()))) < maxLongitudeDistance()){
    				    		LatLng end = new LatLng(Double.parseDouble(busStopList.get(i).getLatitude()), Double.parseDouble(busStopList.get(i).getLongitude()));
    					   		String distance = getDistance.GetRoutDistane(getFromPosition().latitude, getFromPosition().longitude, end.latitude, end.longitude, "walking");

    					   		//Add values in DB
    					   		db.insertDistancesInDB(busStopList.get(i).getName(), distance, busStopList.get(i).getLocationId(), "from");
    					   		
    					   		System.out.println("Distances from current location to nearby bus stops: " + distance + " to bus stop " + busStopList.get(i).getName());
    				    	}
    				    }
        			}
        			
        			//Gets distances for the "to" location - destination location
        			if(locations[1].equals("to")){
	           			 for (int i = 0; i < busStopList.size(); i++) {
	    				    	if(Math.abs((getToPosition().latitude - Double.parseDouble(busStopList.get(i).getLatitude()))) < maxLatitudeDistance()  &&  Math.abs((getToPosition().longitude - Double.parseDouble(busStopList.get(i).getLongitude()))) < maxLongitudeDistance()){
	    				    		LatLng end = new LatLng(Double.parseDouble(busStopList.get(i).getLatitude()), Double.parseDouble(busStopList.get(i).getLongitude()));
	    					   		String distance = getDistance.GetRoutDistane(getToPosition().latitude, getToPosition().longitude, end.latitude, end.longitude, "walking");
	    				
	    					   		//Inserting values in DB
	    					   		db.insertDistancesInDB(busStopList.get(i).getName(), distance, busStopList.get(i).getLocationId(), "to");
	    				    	}
	    				    }
        			}
        			
        		distanceListFromDest = db.getDistanceListByLoc("from");
        		distanceListToDest = db.getDistanceListByLoc("to");

        		System.out.println("distanceListFrom size" + distanceListFromDest.size());
        		System.out.println("distanceListTo size" + distanceListToDest.size());
        		
        		System.out.println("distance to ");
        		for (int i = 0; i < distanceListToDest.size(); i++) {
        			System.out.println(distanceListToDest.get(i).getBusStopName());
        			System.out.println(distanceListToDest.get(i).getDistance());
				}
        		
        		return "finished";
        	
        }
        
        @Override
        protected void onPostExecute(String params) {
        		tripPlanner();
        }
    }
    
    
	public class CustomComparator implements Comparator<DistanceBusStops> {
	    @Override
	    public int compare(DistanceBusStops o1, DistanceBusStops o2) {
	        return o1.getDistance().compareTo(o2.getDistance());
	    }
	}
	
	public class CustomWeightComparator implements Comparator<PossibleRoute> {
	    @Override
	    public int compare(PossibleRoute o1, PossibleRoute o2) {
	        return Double.compare(o1.getWeight(),o2.getWeight());
	    }
	}
	public class CustomTotalTimeComparator implements Comparator<PossibleRoute> {
	    @Override
	    public int compare(PossibleRoute o1, PossibleRoute o2) {
	        return Double.compare(o1.getTotal_time(),o2.getTotal_time());
	    }
	}
	
	
/******************
 * Async class to recieve schedules for bus stops based on id
**************************************************************** */
public class ScheduleTimeTask extends AsyncTask<URI, Void, JSONObject[] > {
	private static final String TAG = "HTTP_TASK";
	
	HttpTaskHandler taskHandler;

    @Override
    protected JSONObject[] doInBackground(URI...urls) {
    	HttpClient client = new DefaultHttpClient();
  
    		JSONObject[] json = new JSONObject[urls.length];
    		for (int i = 0; i < urls.length; i++) {
    			HttpGet httpGet = new HttpGet(urls[i]);
    			
    			try {
		        	HttpResponse response =  client.execute(httpGet);

		        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
					StringBuilder builder = new StringBuilder();
					for (String line = null; (line = reader.readLine()) != null; ) {
					    builder.append(line).append("\n");
					}
				JSONTokener tokener = new JSONTokener(builder.toString());
				json[i] = new JSONObject(tokener);
				
		        } catch (Exception e) {
		        	Log.e(TAG,e.toString());
					e.printStackTrace();
					return null;
				}
			}
    		return json;
    }

    
    @Override
    protected void onPostExecute(JSONObject[] json) {
        if(json != null) {  
        	System.out.println("Schedule time task success");
        	
        	System.out.println(json[0].toString());
        	
        	if(schedulesByStopListFromDest.size()>0){
        		schedulesByStopListFromDest.clear();
        	}
        	

        		for (int j = 0; j < json.length ; j++) {
        			JSONArray schedules = new JSONArray();
        			String busStopId = null;
	        		try {
	        			schedules = json[j].getJSONArray("schedule");
					} catch (JSONException e) {
						e.printStackTrace();
					}
		        	try {
						String line = json[j].getString("busstopID");
						busStopId = line;
//									System.out.println(line);
					} catch (JSONException e) {
						e.printStackTrace();
					}
		        	
		        	for (int i = 0; i < schedules.length(); i++) {
		        		JSONObject c = new JSONObject(); 
		        		
		        		String linenr = null;
		        		String name = null;
		        		
			        	try {
							c = schedules.getJSONObject(i);
						} catch (JSONException e1) {
							e1.printStackTrace();
						}
			        	try {
			        		linenr = c.getString("line");
						} catch (JSONException e) {
							e.printStackTrace();
						}
			        	try {
			        		name = c.getString("name");
						} catch (JSONException e) {
							e.printStackTrace();
						}
			        	
			        	JSONArray departures = new JSONArray();
			        	try {
			        		departures = c.getJSONArray("departures");
						} catch (JSONException e) {
							e.printStackTrace();
						}
			        	
			        	int length = 1;
			        	//We only need the first 4 departure
			        	if(departures.length()>4){
			        		length = 4;
			        	}else{
			        		length = departures.length();
			        	}
			        	
			        	for (int k = 0; k < length; k++) {
			        		
			        		SchedulesByBusStop schedule = new SchedulesByBusStop();
			        		schedule.setBusStopId(busStopId);
			        		schedule.setLine(linenr);
			        		schedule.setDestination(name);
			        		
			        		JSONObject d = new JSONObject(); 
				        	try {
								d = departures.getJSONObject(k);
							} catch (JSONException e1) {
								e1.printStackTrace();
							}
			        		
			        		try {
								int line = d.getInt("id");
								schedule.setTripId(line);
							} catch (JSONException e) {
								e.printStackTrace();
								break;
							}
			        		try {
								String line = d.getString("t");
								schedule.setScheduledDepartureTime(line);
							} catch (JSONException e) {
								e.printStackTrace();
							}
			        
			        		schedulesByStopListFromDest.add(schedule);
			        	}
		        	}
        		} 
        	
        	System.out.println("schedulebystoplist size = "+schedulesByStopListFromDest.size());

        	
        	new TripTask().execute("start");
        }
        else {
        	System.out.println("task failed");
	        }
	    }
}

			
			
		    /******************
		     * Async class to receive trips for bus schedules
		    **************************************************************** */
					public class TripTask extends AsyncTask<String, Void, JSONObject[] > {
						private static final String TAG = "HTTP_TASK";
						

					    @Override
					    protected JSONObject[] doInBackground(String...params) {
					    	
					    	 List<URI> uriList = new ArrayList<URI>();
							 
							 Calendar c = Calendar.getInstance();
						     SimpleDateFormat df2 = new SimpleDateFormat("dd.MM.yyyy");
						     String toDay = df2.format(c.getTime());
						     System.out.println(toDay);
							 
							 for (int i = 0; i < schedulesByStopListFromDest.size(); i++) {
							
								 try {
										System.out.println("Kobler opp for  finne trips");
										uriList.add(new URI("http://bartebuss.no/api/trip/"+schedulesByStopListFromDest.get(i).getTripId()+"/"+toDay));
						
									} catch (URISyntaxException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
										System.out.println("could not instansiate url");
									}
							 }
							 
							 URI[] uri = new URI[uriList.size()];
							 uriList.toArray(uri);
					    	
							 
					    	HttpClient client = new DefaultHttpClient();
					    	
					    	
					    		JSONObject[] json = new JSONObject[uri.length];
					    		for (int i = 0; i < uri.length; i++) {
					    			HttpGet httpGet = new HttpGet(uri[i]);
					    			
					    			try {
							        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
							        	HttpResponse response =  client.execute(httpGet);
							        	
							        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
										StringBuilder builder = new StringBuilder();
										for (String line = null; (line = reader.readLine()) != null; ) {
										    builder.append(line).append("\n");
										}
									JSONTokener tokener = new JSONTokener(builder.toString());
									json[i] = new JSONObject(tokener);
									
							        } catch (Exception e) {
							        	Log.e(TAG,e.toString());
										e.printStackTrace();
										return null;
									}
								}
					    		return json;
					    }

					    @Override
					    protected void onPostExecute(JSONObject[] json) {
					        if(json != null) { 
					        	System.out.println("trip task success");
					        
					        	if(tripsList.size()>0){
					        		tripsList.clear();
					        	}
					        	
					        	
					        		for (int j = 0; j < json.length ; j++) {
					        			String startId = schedulesByStopListFromDest.get(j).getBusStopId();
					        			String depTime = schedulesByStopListFromDest.get(j).getScheduledDepartureTime();
					        			
					        			Trip trip = new Trip();
					        			
					        			JSONArray stops = new JSONArray();
					        		
					        			String lineNr = null;
					        			String tripID = null;
					        			
						        		try {
						        			stops = json[j].getJSONArray("stops");
										} catch (JSONException e) {
											e.printStackTrace();
										}
						        		try {
						        			lineNr = json[j].getString("line");
						        			trip.setLine(lineNr);
										} catch (JSONException e) {
											e.printStackTrace();
										}
						        		try {
						        			tripID = json[j].getString("tripID");
						        			trip.setTripID(tripID);
										} catch (JSONException e) {
											e.printStackTrace();
										}
						        		
						        		trip.setBusStopId(startId);
						        		
							        	for (int i = 0; i < stops.length(); i++) {
							        		JSONObject c = new JSONObject(); 
							        		Stops stop = new Stops();
							        		
							        		stop.setLine(lineNr);
							        		stop.setStartBusStopId(startId);
							        		stop.setDepartureTimeFromStart(depTime);
							        		stop.setTripId(tripID);
								        	try {
												c = stops.getJSONObject(i);
											} catch (JSONException e1) {
												e1.printStackTrace();
											}
								        	try {
												String line = c.getString("busstopID");
												stop.setBusstopID(line);
												
////												//If it's one of the end stops break, as we don't need to gather more stops
//												if(db.checkIfDistanceTableHoldBusStopID(line)!=null){
//													break;
//												}
//												System.out.println(line);
											} catch (JSONException e) {
												e.printStackTrace();
											}
								        	try {
												String line = c.getString("time");
												stop.setTime(line);
											} catch (JSONException e) {
												e.printStackTrace();
											}
								        	try {
												String line = c.getString("destination");
												stop.setDestination(line);
											} catch (JSONException e) {
												e.printStackTrace();
											}
								        	
								        	trip.addStop(stop);
								        
//								        	stopsList.add(stop);
								        }	
							        	
							        	tripsList.add(trip);
							        
							        }
					        		
//							        getTravelRoute();
							        new GetTravelRouteTask().execute("start");
					        }else {
					        	System.out.println("task failed");
					        }
					    }   
				}




					public LatLng getFromPosition() {
						return fromPosition;
					}

					public void setFromPosition(LatLng fromPosition) {
						this.fromPosition = fromPosition;
					}

					public LatLng getToPosition() {
						return toPosition;
					}

					public void setToPosition(LatLng toPosition) {
						this.toPosition = toPosition;
					}  
					
					
				
					
					
					 /******************
				     * Async class to receive trips for det chosen best possible route
				    **************************************************************** */
							public class GetTravelRouteTask extends AsyncTask<String, Void, PossibleRoute> {
								
							    @Override
							    protected PossibleRoute doInBackground(String...routes) {
							    	
							    	//Get all bus stop IDs from the distance table in DB close to the "to" location - destination
									List<String> idToDest = db.getAllBusStopIDfromDistanceTable("to");

									for (int i = 0; i < schedulesByStopListFromDest.size(); i++) {
										for (int j = 0; j < tripsList.size(); j++) {
											
											if(String.valueOf(schedulesByStopListFromDest.get(i).getTripId()).equals(tripsList.get(j).getTripID()) 
													&& schedulesByStopListFromDest.get(i).getLine().equals(tripsList.get(j).getLine()) && schedulesByStopListFromDest.get(i).getBusStopId().equals(tripsList.get(j).getBusStopId())){
												
												for (int k = 0; k < idToDest.size(); k++) {
													boolean containsStartAndEnd = doesTripContainStop(schedulesByStopListFromDest.get(i).getBusStopId(), idToDest.get(k), tripsList.get(j));
													if(containsStartAndEnd){
														
														System.out
																.println("tripid "+schedulesByStopListFromDest.get(i).getTripId());
														
														//Is a possible route
														PossibleRoute posRoute = new PossibleRoute();
													
														List<DistanceBusStops> distObj = db.getDistanceObjectByLocID(schedulesByStopListFromDest.get(i).getBusStopId());
														String dist = distObj.get(0).getDistance();
														String res = "";
														
														System.out.println("dist to close from stop " + dist);
														
														if(dist.charAt(0)!='T' && dist!=null){
															//If value is given in km (e.g. 1.3 km)
															if(dist.contains(".")){
																for (int p= 0; p < dist.length(); p++) {
																	res+= dist.charAt(p);
																	if(dist.charAt(p+1) == ' '){
																		break;
																	}
																}
																double distvalue = Double.parseDouble(res);
																posRoute.setW1((distvalue/WALKING_SPEED)*MINUTES_IN_HOUR);
																System.out.println("min to walk " +(distvalue/WALKING_SPEED)*MINUTES_IN_HOUR);
															}
															//Else if value is given in meter (e.g. 70 m)
															else{
																for (int o= 0; o < dist.length()-1; o++) {
																	res+= dist.charAt(o);
																	if(dist.charAt(o+1) == ' '){
																		break;
																	}
																}
																double distvalue = Double.parseDouble(res);
																double distvalueInKm = distvalue/100;
																posRoute.setW1((distvalueInKm/WALKING_SPEED)*MINUTES_IN_HOUR);
																System.out.println("min to walk " +(distvalueInKm/WALKING_SPEED)*MINUTES_IN_HOUR);
															}
														}
														
														//Can user make it to the bus stop in time?
														
														//String s1 is on the format e.g. "2013-95-15 11:53" and needs to be modified 
														String s2mod =  schedulesByStopListFromDest.get(i).getScheduledDepartureTime().substring(11, 16);
														System.out.println("deptime " +s2mod);
														boolean isTimePassed = TimeIsPassed(getTimeRightNow(),s2mod);
														
														if(!isTimePassed){
															int minToDep = getTimeUntilBusDeparts(getTimeRightNow(), s2mod);
																
															System.out.println("min to dep " +minToDep);
															
																if((minToDep - posRoute.getW1()) >= 0){
															
																posRoute.setWait_time(minToDep - posRoute.getW1());
																	
																posRoute.setStartBusStopId(schedulesByStopListFromDest.get(i).getBusStopId());
																posRoute.setEndBusStopId(idToDest.get(k));
																posRoute.setLine(schedulesByStopListFromDest.get(i).getLine());
																posRoute.setTripId(schedulesByStopListFromDest.get(i).getTripId());
																posRoute.setDepartureBusTime(schedulesByStopListFromDest.get(i).getScheduledDepartureTime());
																posRoute.setTrips(tripsList.get(j));
		
																possibleRouteList.add(posRoute);
																}
														}
														
													}
												}
												
											}
										}
									}
									
									if(possibleRouteList.size()>=3){
										for (int l = 0; l < 3; l++) {
											System.out.println("POSSIBLE ROUTE \n");
											System.out.println("dep time "+possibleRouteList.get(l).getDepartureBusTime());
											System.out.println("total time " +possibleRouteList.get(l).getTotal_time());
											System.out.println("wait time " +possibleRouteList.get(l).getWait_time());
											System.out.println("travel time "+possibleRouteList.get(l).getW2());
											System.out.println("walk  time1 "+possibleRouteList.get(l).getW1());
											System.out.println("walk  time2 "+possibleRouteList.get(l).getW3());
										}
									}
									else if(possibleRouteList.size()>=2){
										for (int l = 0; l < 2; l++) {
											System.out.println("POSSIBLE ROUTE \n");
											System.out.println("dep time "+possibleRouteList.get(l).getDepartureBusTime());
											System.out.println("total time " +possibleRouteList.get(l).getTotal_time());
											System.out.println("wait time " +possibleRouteList.get(l).getWait_time());
											System.out.println("travel time "+possibleRouteList.get(l).getW2());
											System.out.println("walk  time1 "+possibleRouteList.get(l).getW1());
											System.out.println("walk  time2 "+possibleRouteList.get(l).getW3());
										}
									}
									
									//Get the best route based on weight of all the possible routes
									PossibleRoute bestRoute = getBestPossibleRoute();
									//Draw this route on the map
									if(bestRoute!=null){
									System.out.println("THE BEST ROUTE \n");
									System.out.println("dep time "+bestRoute.getDepartureBusTime());
									System.out.println("total time " +bestRoute.getTotal_time());
									System.out.println("wait time " +bestRoute.getWait_time());
									System.out.println("travel time "+bestRoute.getW2());
									System.out.println("walk  time1 "+bestRoute.getW1());
									System.out.println("walk  time2 "+bestRoute.getW3());
									return bestRoute;
									}
									else{
										return null;
									}
								
									
								 }
							    
							    
							    @Override
							    protected void onPostExecute(PossibleRoute bestRoute) {
							    	
							    	if(bestRoute!=null){
							    		System.out.println("best route "+ bestRoute.toString());
										
										drawBestRouteOnMap(bestRoute);
									}
									//TODO : handle this
									else{
										System.out.println("NO BEST ROUTE FOUND ERROR");
										progressDialog.dismiss();
										
									}
							    	
							    }
							      
					    }
					
					
					
					
					 /******************
				     * Async class to receive trips for det chosen best possible route
				    **************************************************************** */
							public class DrawFinalBusRouteTask extends AsyncTask<PossibleRoute, Void, String> {
								
								
							    @Override
							    protected String doInBackground(PossibleRoute...routes) {
							    	PossibleRoute route = routes[0];
									 boolean finished = false;
									 
									 System.out.println("\n\n Draw final bus route task");
//									 System.out.println("stoplist size "+stopsList.size() );
									 System.out.println(route.getTripId());
									 
									 List<Stops> stopsList = route.getTrips().getStops();
									 
									 for (int i = 0; i < stopsList.size(); i++) {
										
										 if(stopsList.get(i).getBusstopID().equals(route.getStartBusStopId())){
//									
//											 if(stopsList.get(i).getBusstopID().equals(route.getStartBusStopId()) && stopsList.get(i).getLine().equals(route.getLine()) ){
											
											for (int j = i; j <stopsList.size()-1 ; j++) {
												
													LatLng from = db.getBusStopLocById(stopsList.get(j).getBusstopID());
													LatLng to = db.getBusStopLocById(stopsList.get(j+1).getBusstopID());
													
													if(from!= null && to!=null){
													
													String url = getDirectionsUrl(from, to, "driving");
													
													//kaller heller en metode her
//													new DownloadTask().execute(url);
													getBusStopRoutePolylines(url);
													}
													
													if(stopsList.get(j+1).getBusstopID().equals(route.getEndBusStopId())){
														System.out.println("final stop " + stopsList.get(j+1).getBusstopID());
														return "finished";
													}
												}
											}
										}
							    	return "finished";
							    }

							    
							    @Override
							    protected void onPostExecute(String string) {
							    	
							    	if(string.equals("finished")){
					    				// Drawing polyline in the Google Map for the i-th route
					    				for (int i = 0; i < polyLineOptionsList.size(); i++) {
					    					polyLineList.add(mMap.addPolyline(polyLineOptionsList.get(i)));
					    				}
					    				System.out.println("polylines drawn upon map");
//				    				
							    	}
							    
							    	progressDialog.dismiss();
							    }
						 }

							
							
		public void getBusStopRoutePolylines(String url){
		
					// For storing data from web service
					String data = "";
							
					try{
						// Fetching the data from web service
						data = downloadUrl(url);
					}catch(Exception e){
						Log.d("Background Task",e.toString());
					}
			
		
		    				JSONObject jObject;	
		    				List<List<HashMap<String, String>>> routes = null;			           
		    	            
		    	            try{
		    	            	jObject = new JSONObject(data);
		    	            	DirectionsJSONParser parser = new DirectionsJSONParser();
		    	            	
		    	            	// Starts parsing data
		    	            	routes = parser.parse(jObject);    
		    	            }catch(Exception e){
		    	            	e.printStackTrace();
		    	            }
		    	            
		    				ArrayList<LatLng> points;
		    				PolylineOptions lineOptions = new PolylineOptions();
		    				MarkerOptions markerOptions = new MarkerOptions();

		    				// Traversing through all the routes
		    				for(int i=0;i<routes.size();i++){
		    					points = new ArrayList<LatLng>();
		    					lineOptions = new PolylineOptions();
		    					
		    					// Fetching i-th route
		    					List<HashMap<String, String>> path = routes.get(i);
		    					
		    					// Fetching all the points in i-th route
		    					for(int j=0;j<path.size();j++){
		    						HashMap<String,String> point = path.get(j);					
		    						
		    						double lat = Double.parseDouble(point.get("lat"));
		    						double lng = Double.parseDouble(point.get("lng"));
		    						LatLng position = new LatLng(lat, lng);	
		    						
		    						points.add(position);		
		    						polylineList.add(position);
		    					}
		    					// Adding all the points in the route to LineOptions
		    					lineOptions.addAll(points);
		    					lineOptions.width(5);
		    					lineOptions.color(Color.RED);	
		    					polyLineOptionsList.add(lineOptions);
		    				}
		    			}

		public String getTime() {
			return time;
		}

		public void setTime(String time) {
			this.time = time;
		}

}
