package com.mso.master;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.LocationSource.OnLocationChangedListener;
import com.google.android.gms.maps.model.LatLng;
import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.location.Address;
import android.location.Geocoder;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;

import android.util.Log;
import android.view.InflateException;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import android.os.AsyncTask;
import com.squareup.otto.Subscribe;


@SuppressLint("ValidFragment")
public class JourneyPlannerFragment extends Fragment{
	
	private Context mContext;
	 
	private static View v;
	private AutoCompleteTextView fromSearch;
	private EditText toSearch;
	private TextView fromToText;
	private TextView fromText;
	private TextView toText;

	private Button descriptivePlanner;
	private Button mapPlanner;
	private ImageButton myLocation1Button;
	private ImageButton myLocation2Button;
	
	private String fromString;
	private String toString;
	
	private ListView lv;
	private ArrayList<String> array_sort= new ArrayList<String>();
	int textlength=0;
	
	private double lat = 0.0;
	private double lon = 0.0;
	
	private OnLocationChangedListener mListener;
	private LocationManager locationManager;
	
	public static ProgressDialog progressDialog;
	
	LayoutInflater layoutInfl;
	ViewGroup mContainer;
	Bundle savedIS;
	
	LatLng fromDestinationCoordinate;
	LatLng toDestinationCoordinate;
	boolean fromDestinationInput = false;
	
	String[] fromAdresses;
	
	
	/*
	 * Constructor
	 */
	
	public JourneyPlannerFragment (Context con){
		this.mContext = con;
	}

	@Override 
	public void onResume() {
	    super.onResume();
	    LocationChangedHandler.getInstance().register(this);
	  }

	 @Override 
	 public void onPause() {
	    super.onPause();
	    LocationChangedHandler.getInstance().unregister(this);
	  }
	
	
	@Override
	    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
	        // Inflate the layout for this fragment
//	        View v = inflater.inflate(R.layout.plannerfragment, container, false);
//	  
//	        v.setBackgroundColor(getResources().getColor(R.color.black));
//	        
	      //Gets the underlying view and saves its state 
			//when moving between Fragment the map is still intact and not changed
		    if (v != null) {
		        ViewGroup parent = (ViewGroup) v.getParent();
		        if (parent != null)
		            parent.removeView(v);

		    }
		    try {
		        v = inflater.inflate(R.layout.plannerfragment, container, false);
		    } catch (InflateException e) {
		        /* map is already there, just return view as it is */
		    }
		    v.setBackgroundColor(getResources().getColor(R.color.black));
	        
	        //Declaring all text fields and buttons and their listeners
	        fromToText = (TextView) v.findViewById(R.id.from_to_text);
//	        fromToText.setBackgroundColor(getResources().getColor(R.color.white));
	        fromToText.setTextColor(getResources().getColor(R.color.white));
	        
	        fromText = (TextView) v.findViewById(R.id.from_text);
//	        fromText.setBackgroundColor(getResources().getColor(R.color.near_black));
	        fromText.setTextColor(getResources().getColor(R.color.white));
	        
	        toText = (TextView) v.findViewById(R.id.to_text);
//	        toText.setBackgroundColor(getResources().getColor(R.color.near_black));
	        toText.setTextColor(getResources().getColor(R.color.white));
	       
	        fromSearch = (AutoCompleteTextView) v.findViewById(R.id.from_search);
	    //    fromSearch.setBackgroundColor(getResources().getColor(R.color.white));
	        fromSearch.setBackground(getResources().getDrawable(R.drawable.frame));
	        
	        
	        //From address text field
	        fromSearch.setOnEditorActionListener(new TextView.OnEditorActionListener() {
				
				@Override
				public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
					
					fromAdresses = new String[3];
					
					//Keep track of which field is being used
					setFromDestinationInput(true);
					
	                // Getting user input location
	                String location = fromSearch.getText().toString();
	 
	                if(location!=null && !location.equals("")){
	                    new GeocoderTask().execute(location);
	                }
	              
	                
	                if (actionId == EditorInfo.IME_ACTION_SEARCH) {
	                	performSearch();
	                    return true;
	                }
	                return false;
	            }

	        	//When pressing search button on keyboard
				private void performSearch() {
					hideKeyboard();
					
				}
			});
	        
	        
	        
	        toSearch = (EditText) v.findViewById(R.id.to_search);
	        toSearch.setBackgroundColor(getResources().getColor(R.color.white));
	        toSearch.setBackground(getResources().getDrawable(R.drawable.frame));
	  
	        //To destination text field
	        toSearch.setOnEditorActionListener(new TextView.OnEditorActionListener() {
	           
	        	@Override
	            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
	        		//Keep track of which field is being used
					setFromDestinationInput(false);
					
	                // Getting user input location
	                String location = toSearch.getText().toString();
	 
	                if(location!=null && !location.equals("")){
	                    new GeocoderTask().execute(location);
	                }
	                
				
	                if (actionId == EditorInfo.IME_ACTION_SEARCH) {
	                	performSearch();
	                    return true;
	                }
	                return false;
	            }

	        	//When pressing search button on keyboard
				private void performSearch() {
					hideKeyboard();
					
				}
	        });

	       
	        myLocation1Button = (ImageButton) v.findViewById(R.id.mylocation1_button);
	        myLocation1Button.setBackground(getResources().getDrawable(R.drawable.location_button));
	        myLocation1Button.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					setFromDestinationCoordinate(getMyPosition());
					fromSearch.setText(R.string.from_my_position);
				}
			});
	        
	        myLocation2Button = (ImageButton) v.findViewById(R.id.mylocation2_button);
	        myLocation2Button.setBackground(getResources().getDrawable(R.drawable.location_button));
	        myLocation2Button.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					setToDestinationCoordinate(getMyPosition());
					toSearch.setText(R.string.to_my_position);
				}
			});
	       
	        
	        descriptivePlanner = (Button) v.findViewById(R.id.descriptive_journey);
	        descriptivePlanner.setTextColor(getResources().getColor(R.color.white));
	        descriptivePlanner.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
					
				
				}
			});
	        
	        mapPlanner = (Button) v.findViewById(R.id.map_journey);
	        mapPlanner.setTextColor(getResources().getColor(R.color.white));
	        mapPlanner.setOnClickListener(new OnClickListener() {
				
				

				@Override
				public void onClick(View v) {

					//start the progress dialog
					progressDialog = ProgressDialog.show(mContext, "", "Laster inn kart...");
					String[] prog = {"map"};
					new FragmentExecuter().execute(prog);
			
				}
			});
	        
	        
	        
	        return v;
	    }
	
	
	 @Subscribe public void onLocationChanged(LocationChangedEvent event) {
		 setLatitude(event.lat);
		 setLongitute(event.lon);
		  }

	
	private void hideKeyboard (){
		InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(fromSearch.getWindowToken(), 0);
	}



	public void setLatitude (double latitude){
		lat = latitude;
	}
	
	public void setLongitute(double longitude){
		lon = longitude;
	}

	public double getLatitude (){
		return lat;
	}
	
	public double getLongitute(){
		return lon;
	}

	public LatLng getMyPosition(){
		LatLng pos = new LatLng(getLatitude(), getLongitute());
		return pos;
	}

	public LatLng getFromDestinationCoordinate() {
		return fromDestinationCoordinate;
	}


	public void setFromDestinationCoordinate(LatLng fromDestinationCoordinate) {
		this.fromDestinationCoordinate = fromDestinationCoordinate;
	}


	public LatLng getToDestinationCoordinate() {
		return toDestinationCoordinate;
	}


	public void setToDestinationCoordinate(LatLng toDestinationCoordinate) {
		this.toDestinationCoordinate = toDestinationCoordinate;
	}
	
	public boolean isFromDestinationInput(){
		if(fromDestinationInput == true){
			return true;
		}
		return false;
	}
	
	public void setFromDestinationInput(boolean bol){
		fromDestinationInput = bol;
	}

	
	
	
	
	
	// An AsyncTask class for accessing ..
    private class FragmentExecuter extends AsyncTask<String, Void, String>{
 
    	
    	@Override
		protected String doInBackground(String... progress) {
        	
        	if(getFromDestinationCoordinate()!=null && getToDestinationCoordinate()!=null){
				// Create new journey map fragment and transaction
				MapFragment newFragment = new JourneyMapFragment(mContext, getFromDestinationCoordinate(), getToDestinationCoordinate(), getMyPosition());
				android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
				transaction.setCustomAnimations(android.R.animator.fade_in,
                        android.R.animator.fade_out);

				// Replace whatever is in the fragment_container view with this fragment,
				// and add the transaction to the back stack
				transaction.replace(R.id.fragment_container, newFragment);
				transaction.addToBackStack(null);
				
				if(newFragment.isHidden()){
					transaction.show(newFragment);
				}
					// Commit the transaction
					transaction.commit();
						
			}
        	
        	if(progress[0].equals("map")){
				String prog = "Laster inn kart...";
				return prog;
			}
        	String prog2 = "Laster inn reisebeskrivelse";
        	return prog2;
        }
        
      
    	@Override
        protected void onPostExecute(String prog) {
        	progressDialog.dismiss();
        }

	
    }
	
	
	
	
	
	/*
	 * ASYNS GEOCODING FOR ADDRESS
	 */
	
	// An AsyncTask class for accessing the GeoCoding Web Service
    private class GeocoderTask extends AsyncTask<String, Void, List<Address>>{
 
    	
        @Override
        protected List<Address> doInBackground(String... locationName) {
            // Creating an instance of Geocoder class
            Geocoder geocoder = new Geocoder(mContext);
            List<Address> addresses = null;
 
            try {
                // Getting a maximum of 3 Address that matches the input text
                addresses = geocoder.getFromLocationName(locationName[0], 3);
            } catch (IOException e) {
                e.printStackTrace();
            }
            return addresses;
        }
 
        
        
        @Override
        protected void onPostExecute(List<Address> addresses) {
 
            if(addresses==null || addresses.size()==0){
                Toast.makeText(mContext, "No Location found", Toast.LENGTH_SHORT).show();
            }
 
            // Clears all the existing markers on the map
//            mMap.clear();
 
            else{
            // Adding Markers on Google Map for each matching address
            for(int i=0;i<addresses.size();i++){
 
                Address address = addresses.get(i);
                
                if(address.getSubAdminArea().equals("Trondheim")){
                
                // Creating an instance of GeoPoint, to display in Google Map
                LatLng latlng = new LatLng(address.getLatitude(), address.getLongitude());
               
                if(isFromDestinationInput()){
                	setFromDestinationCoordinate(latlng);
                	fromAdresses[i] = address.getAddressLine(i);
                	System.out.println(fromAdresses[i] );
                }
                else if(!isFromDestinationInput()){
                	setToDestinationCoordinate(latlng);
                }
 
                
//                
//                String addressText = String.format("%s, %s",
//                address.getMaxAddressLineIndex() > 0 ? address.getAddressLine(0) : "",
//                address.getCountryName());
                }
// 
//                MarkerOptions markerOptions = new MarkerOptions();
//                markerOptions.position(latlng);
//                markerOptions.title(addressText);
// 
//                mMap.addMarker(markerOptions);
// 
//                // Locate the first location
//                if(i==0)
//                    mMap.animateCamera(CameraUpdateFactory.newLatLng(latlng));
            }
            }
        }
    }

	
}