package com.mso.master;

import com.squareup.otto.Bus;

/**
 * Maintains a singleton instance for obtaining the bus. Ideally this would be replaced with a more efficient means
 * such as through injection directly into interested classes.
 */
public final class LocationChangedHandler {
  private static final Bus BUS = new Bus();

  public static Bus getInstance() {
    return BUS;
  }

  private LocationChangedHandler() {
    // No instances.
  }
}