package com.mso.master;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;


import com.squareup.otto.Produce;
import com.squareup.otto.Subscribe;



import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.ActionBar.Tab;
import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.res.AssetManager;
import android.graphics.Color;
import android.graphics.drawable.AnimationDrawable;
import android.graphics.drawable.ColorDrawable;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ImageView;
import android.widget.Toast;

@SuppressLint("SdCardPath")
public class MainActivity extends Activity implements LocationListener{
	public static Context appContext;

	private GoogleMap mMap;
	private Context context;
	private Criteria myCriteria;
	private LocationManager locationManager;
	private String provider;
	
	private double lat;
	private double lon;
	
	private DBaccess db;

	private List<BusStop> busStopList;
	private List<BusStop> busStopListReduced;
	
	private LatLng myPosition;	
	private List<String> distances;

	private ArrayList<LatLng> markerPoints;
	private MarkerOptions options;
	private List<LatLng> polylineList;
	private List<LatLng> currentPolylineList;
	private List<String> busStopNames;

	
	ProgressDialog progressDialog;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		appContext = getApplicationContext();
		
//		//Store assets data on SD card 
		putExcelFileOnSD();
		putRoutesOnSD();
		
		//DB coonection
		db = new DBaccess(this);

//		db.getBusStopsIfNotAlreadyDone();
		busStopList = new ArrayList<BusStop>();
		busStopList = db.getAllBusStops();
		System.out.println("busstoplist size =");
		System.out.println(busStopList.size());
		if(busStopList.size()==0){
			URI uri = null;
			try {
				System.out.println("Kobler opp for  hente ut busstopper fra BusBuddy API'et");
				uri = new URI("http://api.busbuddy.no/api/1.4.4/busstops?apiKey=1x1ysRk94OTFa6zwvxMo");
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("could not instansiate url");
			}
			//start the progress dialog
			progressDialog = ProgressDialog.show(this, "", "Laster inn busstopper...");
			new GetBusStopsTask().execute(uri);
		}
		
		
		busStopNames = db.getAllBusStopNames();
		
		busStopList = db.getAllBusStops();
		System.out.println("bus stop list size in Main activity" +busStopList.size());


		polylineList = db.getPolylines("5");

		 //Location manager 
        LocationManager service = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        boolean enabledGPS = service
                .isProviderEnabled(LocationManager.GPS_PROVIDER);
        boolean enabledWiFi = service
                .isProviderEnabled(LocationManager.NETWORK_PROVIDER);
        
        //Criteria
        myCriteria = new Criteria();
        myCriteria.setAccuracy(Criteria.ACCURACY_COARSE);
        locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        Criteria criteria = new Criteria();
        provider = locationManager.getBestProvider(myCriteria, false);
        Location location = locationManager.getLastKnownLocation(provider);

        // Initialize the location fields
        if (location != null) {
            onLocationChanged(location);
        } else {
            //do something
        }

        if(locationManager != null){
            boolean gpsIsEnabled = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
            boolean networkIsEnabled = locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);
        
        if(networkIsEnabled){
            locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 5000L, 10F, this);
        }
        else if(gpsIsEnabled){
            locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 5000L, 10F, this);
        }
        else {
            //Show an error dialog that GPS is disabled...
        }
        }
        else{
            //Show some generic error dialog because something must have gone wrong with location manager.
        }
        
        
	    //ActionBar gets initiated
        ActionBar actionbar = getActionBar();
        
//        actionbar.setDisplayShowHomeEnabled(false);
        actionbar.setDisplayShowTitleEnabled(false);
//        actionbar.setHomeButtonEnabled(true);
        actionbar.setLogo(R.drawable.icon);
//        actionbar.setStackedBackgroundDrawable(new ColorDrawable(getResources().getColor(R.color.green)));
      
        
        context = this;
     
      //Tell the ActionBar we want to use Tabs.
        actionbar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
      //initiating both tabs and set text to it.
        ActionBar.Tab ride = actionbar.newTab().setIcon(R.drawable.bus);
        ActionBar.Tab planner = actionbar.newTab().setText("Planlegg \n reisen");
        ActionBar.Tab realtime = actionbar.newTab().setText("Sanntid \n busstopp");
//        ActionBar.Tab temp = actionbar.newTab().setText("Nr \n meg");
 
     //create the two fragments we want to use for display content
        Fragment rideFragment = new MyMapFragment(this.context, busStopList, polylineList);
        Fragment plannerFragment = new JourneyPlannerFragment(this.context);
        Fragment realtimeFragment = new RealTimeFragment(this.context, busStopList, busStopNames);
 
    //set the Tab listener. Now we can listen for clicks.
        ride.setTabListener(new MyTabsListener(rideFragment));
        planner.setTabListener(new MyTabsListener(plannerFragment));
        realtime.setTabListener(new MyTabsListener(realtimeFragment));
  
        //add the tabs to the actionbar
        actionbar.addTab(ride);
        actionbar.addTab(planner);  
        actionbar.addTab(realtime);      
	}
	

	 @Override
	    public void onResume() {
	        super.onResume();

	      //Register for location updates using a Criteria, and a callback on the specified looper thread.
	        locationManager.requestLocationUpdates(
	          0L,    		//minTime
	          0.0f,   	    //minDistance
	          myCriteria,   //criteria
	          this,   	    //listener
	          null);        //looper
	        
	        
	     // Register ourselves so that we can provide the initial value.
	        LocationChangedHandler.getInstance().register(this);
	    }

	    
	    @Override
	    public void onPause() {
	    	  super.onPause();
//	    	  mMap.setLocationSource(null);
//	    	  locationManager.removeUpdates(this);
	    	 

	    	//Always unregister when an object no longer should be on the bus.
	    	 LocationChangedHandler.getInstance().unregister(this);
	    	 
	    	 
	    }
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()) {
//			case R.id.menuitem_search:
//				Toast.makeText(appContext, "search", Toast.LENGTH_SHORT).show();
//				return true;
//			case R.id.menuitem_add:
//				Toast.makeText(appContext, "add", Toast.LENGTH_SHORT).show();
//				return true;
//			case R.id.menuitem_share:
//				Toast.makeText(appContext, "share", Toast.LENGTH_SHORT).show();
//				return true;
//			case R.id.menuitem_feedback:
//				Toast.makeText(appContext, "feedback", Toast.LENGTH_SHORT).show();
//				return true;
			case R.id.menuitem_about:
				Toast.makeText(appContext, "about", Toast.LENGTH_SHORT).show();
				return true;
//			case R.id.menuitem_quit:
//				Toast.makeText(appContext, "quit", Toast.LENGTH_SHORT).show();
//				return true;
		}
		return false;
	}
	
	
	  @Override
	    protected void onSaveInstanceState(Bundle outState) {
	        super.onSaveInstanceState(outState);
	        outState.putInt("tab", getActionBar().getSelectedNavigationIndex());
	    }
	  
	  
	  @Override
	  public void onBackPressed() {
		
	    if (getFragmentManager().findFragmentByTag("busmap") != null) {
	    	getFragmentManager().popBackStack();
//	    	getFragmentManager().popBackStackImmediate();
//	    	getFragmentManager().popBackStackImmediate();
	    }	
//	    	android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
//			transaction.setCustomAnimations(android.R.animator.fade_in,
//                    android.R.animator.fade_out);
//			transaction.show(realtimeFragment);
//			transaction.commit();
//			if(newFragment.isHidden()){
//				transaction.show(newFragment);
//			}
//				// Commit the transaction
//				transaction.commit();
				
//				
//	    } else {
////	    	getFragmentManager().popBackStackImmediate();
	    	super.onBackPressed();
	  }


		//Retrieve a bus stop list from the assets POI reader
		public void getBusStopList (){
			busStopList = db.getAllBusStops();
//			busStopList = poiReader.getBusStopList();
		}
	  
		public List<BusStop> removeDuplicates (List<BusStop> stops){
			List<BusStop> res = new ArrayList<BusStop>();
			for (int i = 0; i < busStopList.size()-1; i++) {
				if(!busStopList.get(i).getName().equals(busStopList.get(i+1).getName())){
					res.add(busStopList.get(i));
				}
				if(i==busStopList.size()-2){
					res.add(busStopList.get(i));
				}
			}
			
			return res;
		}
		
		
		public double maxLatitudeDistance (){
			return 63.4307 - 63.4278;
		}
		
		public double maxLongitudeDistance(){
			return 10.3927 - 10.3859;
		}
		
	  
		private void putExcelFileOnSD(){
			new File("/mnt/sdcard/master/").mkdir();
			AssetManager assetManager = getAssets();
			String[] files = null;
			try{
				files = assetManager.list("");
			}
			catch(IOException e){
				Log.e("tag", e.getMessage());
			}
			File excelFile = new File("/mnt/sdcard/master/busstoplist.xls");
			if(!excelFile.exists()){
				for(String filename : files){
					if(filename.contains("bussto")){
						InputStream in = null;
						OutputStream out = null;
						try{
							in = assetManager.open(filename);
							System.out.println("copying " + filename);
							out = new FileOutputStream("/sdcard/master/" + filename);
							copyFile(in, out);
							in.close();
							in = null;
							out.flush();
							out.close();
							out = null;
							Toast.makeText(getApplicationContext(), 
									"excelFile added to "+ excelFile, Toast.LENGTH_LONG).show();
						} 
						catch(Exception e) {
							Log.e("tag", e.getMessage());
						}    	
					}
				}
			}
		}
		
		
		private void putRoutesOnSD(){
			new File("/mnt/sdcard/master/").mkdir();
			AssetManager assetManager = getAssets();
			String[] files = null;
			try{
				files = assetManager.list("");
			}
			catch(IOException e){
				Log.e("tag", e.getMessage());
			}
			File excelFile = new File("/mnt/sdcard/master/busroutes.xls");
			if(!excelFile.exists()){
				for(String filename : files){
					if(filename.contains("rout")){
						InputStream in = null;
						OutputStream out = null;
						try{
							in = assetManager.open(filename);
							System.out.println("copying " + filename);
							out = new FileOutputStream("/sdcard/master/" + filename);
							copyFile(in, out);
							in.close();
							in = null;
							out.flush();
							out.close();
							out = null;
							Toast.makeText(getApplicationContext(), 
									"excelFile added to "+ excelFile, Toast.LENGTH_LONG).show();
						} 
						catch(Exception e) {
							Log.e("tag", e.getMessage());
						}    	
					}
				}
			}
		}

		private void copyFile(InputStream in, OutputStream out) throws IOException {
		    byte[] buffer = new byte[1024];
		    int read;
		    while((read = in.read(buffer)) != -1){
		      out.write(buffer, 0, read);
		    }
		}

		
		//Notify listeners and subscribers about location changed events
		 @Produce public LocationChangedEvent produceLocationEvent() {
			    // Provide an initial value for location based on the last known position.
			 	LatLng Coord = new LatLng(getLat(), getLon());
			    return new LocationChangedEvent(Coord);
			  }
		

		
		@Override
		public void onLocationChanged(Location location) {

			//Latitude and longitude
			setLat(location.getLatitude());
			setLon(location.getLongitude());

			LocationChangedHandler.getInstance().post(produceLocationEvent());	
		}
		

		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {
			// TODO Auto-generated method stub
			
		}

		public double getLat() {
			return lat;
		}

		public void setLat(double lat) {
			this.lat = lat;
		}

		public double getLon() {
			return lon;
		}

		public void setLon(double lon) {
			this.lon = lon;
		}


		@Override
		public void onProviderDisabled(String arg0) {
			// TODO Auto-generated method stub
			
		}


		@Override
		public void onProviderEnabled(String arg0) {
			// TODO Auto-generated method stub
			
		}

		public DBaccess getDb() {
			return db;
		}


		public void setDb(DBaccess db) {
			this.db = db;
		}   
		

		
		// An AsyncTask class
	    private class DBexecuter extends AsyncTask<Object, Void, String>{
	    	@Override
			protected String doInBackground(Object... params) {
	        	
	    		LatLng[] poly = (LatLng[]) params[0];
	    		String route = (String) params[1];
	    		
	    		for (int i = 0; i < poly.length; i++) {
//	    			System.out.println(poly[i]);
	    			db.addPolyline(poly[i], route);
				} 	
	    		return "ok";   	
	        }
	           
	    	@Override
	        protected void onPostExecute(String prog) {
	   	
	    		System.out.println("added in db");
	        }

	    }
  

	
	class MyTabsListener implements ActionBar.TabListener {
		public Fragment fragment;

		public MyTabsListener(Fragment fragment) {
			this.fragment = fragment;
		}

		@Override
		public void onTabReselected(Tab tab, FragmentTransaction ft) {
//			Toast.makeText(StartActivity.appContext, "Reselected!", Toast.LENGTH_LONG).show();
		}

		@Override
		public void onTabSelected(Tab tab, FragmentTransaction ft) {
			ft.replace(R.id.fragment_container, fragment);
		
		}

		@Override
		public void onTabUnselected(Tab tab, FragmentTransaction ft) {
			ft.remove(fragment);
		}
		
		
	}	
		
		
		
		
		//Async task to connect op Bussbuddy API to get BusStopList
		public class GetBusStopsTask extends AsyncTask<URI, Void, JSONObject > {
			private static final String TAG = "HTTP_TASK";
			
//			HttpTaskHandler taskHandler;

		    @Override
		    protected JSONObject doInBackground(URI...urls) {
		    	// Performed on Background Thread

		    	HttpClient client = new DefaultHttpClient();
				HttpGet httpGet = new HttpGet(urls[0]);
		    	
//		    	HttpUriRequest request = params[0];
//		    	HttpClient client = new DefaultHttpClient();

		        try {
		        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
		        	HttpResponse response =  client.execute(httpGet);

		// TODO handle bad response codes (such as 404, etc)

		        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
					StringBuilder builder = new StringBuilder();
					for (String line = null; (line = reader.readLine()) != null; ) {
					    builder.append(line).append("\n");
					}
				JSONTokener tokener = new JSONTokener(builder.toString());
				JSONObject json = new JSONObject(tokener);
				return json;

		        } catch (Exception e) {
			// TODO handle different exception cases
		        	Log.e(TAG,e.toString());
					e.printStackTrace();
					return null;
				}
		    }

		    
		    @Override
		    protected void onPostExecute(JSONObject json) {
		    	
		    	// Done on UI Thread
		        if(json != null) {    
		        	System.out.println("task success");
		        	System.out.println(json.toString());
		        	
		        	JSONArray busStops = null;
		        	try {
		        		busStops = json.getJSONArray("busStops");
					} catch (JSONException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
		        	
		        	for (int i = 0; i < busStops.length(); i++) {
						JSONObject c = null;
						BusStop busstop = new BusStop();
						try {
							c = busStops.getJSONObject(i);
						} catch (JSONException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						try {
							String line = c.getString("name");
							busstop.setName(line);
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						try {
							String line = c.getString("nameWithAbbreviations");
							busstop.setNameWithAbbreviations(line);
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
//						try {
//							String line = c.getString("busStopMaintainer");
//							busstop.setBusStopMaintainer(line);
//						} catch (JSONException e) {
//							// TODO Auto-generated catch block
//							e.printStackTrace();
//						}
						try {
							String line = c.getString("locationId");
							busstop.setLocationId(line);
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						try {
							String line = c.getString("longitude");
							busstop.setLongitude(line);
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						try {
							String line = c.getString("latitude");
							busstop.setLatitude(line);
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
						
						db.insertBusStopObjectInDB(busstop);
//						busStopList.add(busstop);
		        	
		        	}
		        	busStopList = db.getAllBusStops();
		        	progressDialog.dismiss();
//		        	taskHandler.taskSuccessful(json);
		        } else {
		        	System.out.println("task failed");
//		        	taskHandler.taskFailed();
		        }
		    }
	}

		
		
		
	}


	
