package com.mso.master;


import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;

import jxl.Workbook;
import jxl.write.WritableWorkbook;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.ContextWrapper;
import android.content.Intent;
import android.content.Loader.ForceLoadContentObserver;
import android.graphics.Color;
import android.graphics.Point;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.LocationManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.text.format.Time;
import android.util.Log;
import android.view.Gravity;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnInfoWindowClickListener;
import com.google.android.gms.maps.LocationSource.OnLocationChangedListener;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;
import com.squareup.otto.Produce;
import com.squareup.otto.Subscribe;



@SuppressLint("ValidFragment")
public class MyMapFragment extends MapFragment{
	
	private static View view;
	GoogleMap mMap = null;
	private Context mContext;

	private OnLocationChangedListener mListener;
	private LocationManager locationManager;
	protected MainActivity activity;
	
	private android.app.FragmentManager myFragmentManager;
	private MapFragment myMapFragment;	
	private Criteria myCriteria;
	private String provider;
	private LatLng myPosition;	
	private Marker locationIcon = null;
	private Marker busIcon= null;
	private List<BusStop> busStopList = null;
	private List<String> distances = null;

	private ProgressDialog progressDialogPopup;
	
	private double lat = 0.0;
	private double lon = 0.0;
	
	private double routeLng;
	private double routeLat;
	
	public DBaccess db;
	
	LatLng fromPosition;
	LatLng toPosition;
	
	private boolean locationChanged = false;
	private ArrayList<LatLng> markerPoints;
	private List<Stops> stopsList;
	private MarkerOptions options;
	private List<LatLng> polylineList;
	private List<LatLng> currentPolylineList;
	private List<LatLng> tempPolylineList;
	private List<PolylineOptions> polyLineOptionsList;
	private List<Polyline> polyLineList;
	
	private boolean busStopDrawn = false;
	private boolean busRoutesDrawn = false;
	private boolean busIconDrawn = false;
	private boolean gotMyLocation = false;
	
	private String todaysDate;
	private String timeNow;
	
	DownloadTask task;
	
	String currentRoute;

	private ArrayList<SchedulesByBusStop> scheduleList;

	private String choosenBusStop;
	
	private RadioGroup radioGroup;
	private RadioButton radioButton;
	private ImageButton locationButton;
//	private TextView textViewInfo;
	private List<RadioButton> radioButtonsList;
	
	private String busIdOfBusStopEnabled;
	
	
	ListView listViewPopUp;
	CustomRoutePopUpAdapter adapter;
	
	//Empty Constructor
	public MyMapFragment(){

	}
	
	//Constructor to pass the context argument from parent activity class
	public MyMapFragment(Context con, List<BusStop> busstops, List<LatLng> poly){
		this.mContext = con;
		this.busStopList = busstops;	
		this.polylineList = poly;
		db = new DBaccess(con);
		
		stopsList = new ArrayList<Stops>();
		scheduleList = new ArrayList<SchedulesByBusStop>();
		polyLineOptionsList = new ArrayList<PolylineOptions>();
		polyLineList = new ArrayList<Polyline>();
		radioButtonsList = new ArrayList<RadioButton>();
	}
	
	
	@Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        activity = (MainActivity)getActivity();
    }


	//On create method when fragment is created
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        currentPolylineList = new ArrayList<LatLng>();
        markerPoints = new ArrayList<LatLng>();
        tempPolylineList = new ArrayList<LatLng>();
        
    }
	
	
	//On create view method for fragment
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		super.onCreateView( inflater, container, savedInstanceState );
		
		//Gets the underlying view and saves its state 
		//when moving between Fragment the map is still intact and not changed
	    if (view != null) {
	        ViewGroup parent = (ViewGroup) view.getParent();
	        if (parent != null)
	            parent.removeView(view);
	    }
	    try {
	        view = inflater.inflate(R.layout.mapfragment, container, false);
	    } catch (InflateException e) {
	        /* map is already there, just return view as it is */
	    }

	    //Receives the underlying map
	 	myFragmentManager = getFragmentManager();
	    myMapFragment = (MapFragment)myFragmentManager.findFragmentById(R.id.map_fragment);
	    mMap = myMapFragment.getMap();

	    String time = getTimeRightNow();
	    System.out.println(time);
	    
        //Get Bus Stop list from and draw bus stop markers
	    if(!busStopDrawn){
	    	addBusStops();
	    	busStopDrawn = true;
	    }
	    
	    radioGroup = (RadioGroup) view.findViewById(R.id.radio_group_list_selector);
//	    radioGroup.setVisibility(View.INVISIBLE);
	    
	    locationButton = (ImageButton) view.findViewById(R.id.myMapLocationButton);
	    locationButton.setBackground(getResources().getDrawable(R.drawable.my_location_button));
	    locationButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(getMyPostition(), 14.0f));
				System.out.println("Location button pressed");
			}
		});
	    

	  //Only remove old polyLines from map
		if (polyLineList.size()>0) {
			for (int j = 0; j < polyLineList.size(); j++) {

				 polyLineList.get(j).remove();
				
			}
			polyLineList.clear();
			polylineList.clear();
			polyLineOptionsList.clear();
		}
		//Remove radiobuttons if there are any
		if (radioButtonsList.size()>0) {
			for (int i = 0; i < radioButtonsList.size(); i++) {
				radioGroup.removeView(radioButtonsList.get(i));
			}
		}
		if(busIconDrawn){
			busIcon.remove();
		}

	    System.out.println("current time is: " + getTimeRightNow());

	    mMap.setOnInfoWindowClickListener(new OnInfoWindowClickListener(){
	    	@Override
			public void onInfoWindowClick(Marker marker) {
				// TODO Auto-generated method stub

	    		System.out.println(marker.getTitle());
	    		System.out.println(marker.getTitle().substring(0, 3));
	    		if(marker.getTitle().substring(0, 3).equals("Du ") || marker.getTitle().substring(0, 3).equals("Ta ")){
	    			//Do nothing
	    		}
	    		else{
					String busstop = marker.getTitle();
					LatLng location = marker.getPosition();
					System.out.println("chosen marker location " + location);
	
					double lat = location.latitude;
					double lng = location.longitude;
					
					double roundOffLat = Math.round(lat * 1000000.0) / 1000000.0;
					System.out.println(roundOffLat);
					double roundOffLng = Math.round(lng * 1000000.0) / 1000000.0;
					System.out.println(roundOffLng);
					
					LatLng approxLocation = new LatLng(roundOffLat, roundOffLng);
					
					String locid = db.getBusStopLocidByLocation(approxLocation);
					
					System.out.println("busstop locid from db" + locid);
					setChosenBusStop(busstop);
	
					progressDialogPopup = ProgressDialog.show(mContext, "", "Laster inn bussruter...");  
					
					new BusTask().execute(locid);
	    		}
	    	}
		});
	    return view;
	}
	

    @Override
    public void onResume() {
        super.onResume();
     // Register ourselves so that we can provide the initial value.
        LocationChangedHandler.getInstance().register(this);
    }
    @Override
    public void onPause() {
    	super.onPause();
    	//Always unregister when an object no longer should be on the bus.
    	 LocationChangedHandler.getInstance().unregister(this);
    }

    
    public void setChosenBusStop(String busstop) {
		choosenBusStop = busstop;
	}

    public String getChosenBusStop(String busstop) {
		return choosenBusStop;
	}

   
    public void onClick(View v) {
        	for (int i = 0; i < scheduleList.size(); i++) {
        		if(v.getId()==i){
        			System.out.println("you pressed " + i);
        		}
			}	
    }
    
    
	//Add Markers for Bus Stops on the map
	public void addBusStops (){
		for (int i = 0; i < busStopList.size(); i++) {
			double lat = Double.parseDouble(busStopList.get(i).getLatitude());
			double lon = Double.parseDouble(busStopList.get(i).getLongitude());
			
			LatLng coordinate = new LatLng(lat, lon);
			 locationIcon = mMap.addMarker(new MarkerOptions()
		        .position(coordinate)
		        .title(busStopList.get(i).getName())
		        .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus_stop_icon_green_scaled)));
		}
	}
	

		public List<BusStop> removeDuplicates (List<BusStop> stops){
			List<BusStop> res = new ArrayList<BusStop>();
			for (int i = 0; i < busStopList.size()-1; i++) {
				if(!busStopList.get(i).getName().equals(busStopList.get(i+1).getName())){
					res.add(busStopList.get(i));
				}
				if(i==busStopList.size()-2){
					res.add(busStopList.get(i));
				}
			}
			
			return res;
		}
		
		
		public double maxLatitudeDistance (){
			return 63.4307 - 63.4278;
		}
		
		public double maxLongitudeDistance(){
			return 10.3927 - 10.3859;
		}
		
		public void setMyPostition(LatLng pos){
			myPosition = pos;
		}
		
		public LatLng getMyPostition(){
			return myPosition;
		}
	

	 @Subscribe public void onLocationChanged(LocationChangedEvent event) {
//		 Avoid duplication icon
		 if(locationChanged){
		 locationIcon.remove();
		 }
		
		 setLat(event.lat);
		 setLon(event.lon);
	
		 LatLng coordinate = new LatLng(getLat(), getLon());
		 setMyPostition(coordinate);
		 
		 System.out.println(coordinate);

		 if(!gotMyLocation){
			//Center map around the location icon and zoom in at given zoom level
			mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(getLat(), getLon()), 15.0f));
			gotMyLocation = true;
		 }


		//Add a marker to the current location as a marker overlay
       locationIcon = mMap.addMarker(new MarkerOptions()
       .position(coordinate)
       .anchor((float) 0.5, (float)0.5)
       .title("Du str her")
       .icon(BitmapDescriptorFactory.fromResource(R.drawable.walking_person2)));
 
       locationChanged = true;
		  }


	 public void drawRoute(List<LatLng> poly){
		 PolylineOptions lineOptions = new PolylineOptions();
		 
		 // Adding all the points in the route to LineOptions
			lineOptions.addAll(poly);
			lineOptions.width(5);
			lineOptions.color(Color.RED);	
			
			mMap.addPolyline(lineOptions);	
	 }
	
	public boolean TimeIsPassed(String t2){
		String t1 = getTimeRightNow();
		 
		  int hour1 = Integer.parseInt(t1.substring(0, 2));
		  int hour2 = Integer.parseInt(t2.substring(0, 2));
		  int min1 = Integer.parseInt(t1.substring(3, 5));
		  int min2 = Integer.parseInt(t2.substring(3, 5));

		  if(hour1 > hour2 ){
			  return true;
		  }
		  if(hour1 == hour2 && min1 > min2){
			  return true;
		  }
		  return false;
	}
	
	public void AlterAdapter(){
		 listViewPopUp =  (ListView) view.findViewById(R.id.listView_popup);
         adapter = new CustomRoutePopUpAdapter(mContext, R.layout.row_routepopup, scheduleList);
//			adapter = new ArrayAdapter<SchedulesByBusStop>(mContext, R.layout.row, distanceList);
         	listViewPopUp.setAdapter(adapter);
	}
	
	 
	public double getLat() {
		return lat;
	}

	public void setLat(double lat) {
		this.lat = lat;
	}

	public double getLon() {
		return lon;
	}

	public void setLon(double lon) {
		this.lon = lon;
	}

	
	public void setTodaysDate(){
		 Calendar cal = Calendar.getInstance();
   	     SimpleDateFormat df2 = new SimpleDateFormat("dd.MM.yyyy");
   	     String toDay = df2.format(cal.getTime());
   	     setTodaysDate(toDay);
	}
	
	public String getTimeRightNow(){
		Time today = new Time(Time.getCurrentTimezone());
		today.setToNow();
		int minute = today.minute;
		String min = String.valueOf(minute);
		if(min.length()==1){
			String time = today.hour+":"+"0"+today.minute;
			return time;
		}
		else{
		String time = today.hour+":"+today.minute;
		return time;
		}
	}

	
	private String getDirectionsUrl(LatLng origin,LatLng dest, String mode){
		
		// Origin of route
		String str_origin = "origin="+origin.latitude+","+origin.longitude;
		
		// Destination of route
		String str_dest = "destination="+dest.latitude+","+dest.longitude;		
			
		// Sensor enabled
		String sensor = "sensor=false";			
					
		// Building the parameters to the web service
		String parameters = str_origin+"&"+str_dest+"&"+sensor;
					
		// Output format
		String output = "json";
		
		// Building the url to the web service
		String url = "https://maps.googleapis.com/maps/api/directions/"+output+"?"+parameters+"&"+mode;
		
		
		return url;
	}
	
	/** A method to download json data from url */
    private String downloadUrl(String strUrl) throws IOException{
        String data = "";
        InputStream iStream = null;
        HttpURLConnection urlConnection = null;
        try{
                URL url = new URL(strUrl);

                // Creating an http connection to communicate with url 
                urlConnection = (HttpURLConnection) url.openConnection();

                // Connecting to url 
                urlConnection.connect();

                // Reading data from url 
                iStream = urlConnection.getInputStream();

                BufferedReader br = new BufferedReader(new InputStreamReader(iStream));

                StringBuffer sb  = new StringBuffer();

                String line = "";
                while( ( line = br.readLine())  != null){
                        sb.append(line);
                }
                
                data = sb.toString();

                br.close();

        }catch(Exception e){
                Log.d("Exception while downloading url", e.toString());
        }finally{
                iStream.close();
                urlConnection.disconnect();
        }
        return data;
     }

	
	
	// Fetches data from url passed
	private class DownloadTask extends AsyncTask<String, Void, String>{		
		
		@Override
		protected String doInBackground(String... params) {
				
			// For storing data from web service
			String data = "";
			try{
				// Fetching the data from web service
				data = downloadUrl(params[0]);
			}catch(Exception e){
				Log.d("Background Task",e.toString());
			}
			return data;		
		}
	
		@Override
		protected void onPostExecute(String result) {			
			super.onPostExecute(result);
			ParserTask parserTask = new ParserTask();
			
			// Invokes the thread for parsing the JSON data
			parserTask.execute(result);	
		}		
	}
	
	
	
	/** A class to parse the Google Places in JSON format */
    private class ParserTask extends AsyncTask<String, Integer, String>{
    	
    	// Parsing the data in non-ui thread    	
		@Override
		protected String doInBackground(String... jsonData) {
			
			JSONObject jObject;	
			List<List<HashMap<String, String>>> routes = null;			           
            
            try{
            	jObject = new JSONObject(jsonData[0]);
            	DirectionsJSONParser parser = new DirectionsJSONParser();
            	
            	// Starts parsing data
            	routes = parser.parse(jObject);    
            }catch(Exception e){
            	e.printStackTrace();
            }
            
			ArrayList<LatLng> points;
			PolylineOptions lineOptions = new PolylineOptions();
			MarkerOptions markerOptions = new MarkerOptions();

			// Traversing through all the routes
			for(int i=0;i<routes.size();i++){
				points = new ArrayList<LatLng>();
				lineOptions = new PolylineOptions();
				
				// Fetching i-th route
				List<HashMap<String, String>> path = routes.get(i);
				
				// Fetching all the points in i-th route
				for(int j=0;j<path.size();j++){
					HashMap<String,String> point = path.get(j);					
					
					double lat = Double.parseDouble(point.get("lat"));
					double lng = Double.parseDouble(point.get("lng"));
					LatLng position = new LatLng(lat, lng);	
					
					points.add(position);		
					polylineList.add(position);
				}
				
				// Adding all the points in the route to LineOptions
				lineOptions.addAll(points);
				lineOptions.width(5);
				lineOptions.color(Color.RED);	
				polyLineOptionsList.add(lineOptions);
			}
            return "finished";
		}
		
		// Executes in UI thread, after the parsing process
		@Override
		protected void onPostExecute(String result) {

			// Drawing polyline in the Google Map for the i-th route
//			mMap.addPolyline(lineOptions);	
			for (int i = 0; i < polyLineOptionsList.size(); i++) {
				polyLineList.add(mMap.addPolyline(polyLineOptionsList.get(i)));
			}
		
			System.out.println("polylines drawn upon map");
			progressDialogPopup.dismiss();
		}		
    }   
    
  
	
	public void getBusStopRoutePolylines(String url){
	
	// For storing data from web service
	String data = "";
		
	try{
	// Fetching the data from web service
	data = downloadUrl(url);
	}catch(Exception e){
	Log.d("Background Task",e.toString());
	}
		JSONObject jObject;	
		List<List<HashMap<String, String>>> routes = null;			           
	    
	    try{
	    	jObject = new JSONObject(data);
	    	DirectionsJSONParser parser = new DirectionsJSONParser();
	    	
	    	// Starts parsing data
	    	routes = parser.parse(jObject);    
	    }catch(Exception e){
	    	e.printStackTrace();
	    }
	    
		ArrayList<LatLng> points;
		PolylineOptions lineOptions = new PolylineOptions();
		MarkerOptions markerOptions = new MarkerOptions();

		
		// Traversing through all the routes
		for(int i=0;i<routes.size();i++){
			points = new ArrayList<LatLng>();
			lineOptions = new PolylineOptions();
			
			// Fetching i-th route
			List<HashMap<String, String>> path = routes.get(i);
			
			// Fetching all the points in i-th route
			for(int j=0;j<path.size();j++){
				HashMap<String,String> point = path.get(j);					
				
				double lat = Double.parseDouble(point.get("lat"));
				double lng = Double.parseDouble(point.get("lng"));
				LatLng position = new LatLng(lat, lng);	
				
				points.add(position);		
				polylineList.add(position);
			}
			// Adding all the points in the route to LineOptions
			lineOptions.addAll(points);
			lineOptions.width(5);
			lineOptions.color(Color.RED);	
			polyLineOptionsList.add(lineOptions);
		}
	}
		
    
    
    /******************
     * Async class to recieve schedules routes for bus stops based on id
    **************************************************************** */
			public class ScheduleRoutesTask extends AsyncTask<URI, Void, JSONObject[] > {
				private static final String TAG = "HTTP_TASK";
			
			    @Override
			    protected JSONObject[] doInBackground(URI...urls) {
			    	// Performed on Background Thread

			    	HttpClient client = new DefaultHttpClient();
			    	
			    	if(urls.length==1){
					HttpGet httpGet = new HttpGet(urls[0]);
			    	
			        try {
			        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
			        	HttpResponse response =  client.execute(httpGet);

			        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
						StringBuilder builder = new StringBuilder();
						for (String line = null; (line = reader.readLine()) != null; ) {
						    builder.append(line).append("\n");
						}
						JSONTokener tokener = new JSONTokener(builder.toString());
						JSONObject[] json = new JSONObject[1];
						json[0] = new JSONObject(tokener);
						return json;

			        } catch (Exception e) {
			        	Log.e(TAG,e.toString());
						e.printStackTrace();
						return null;
					}
			    	}
			    	
			    	else{
			    
			    		JSONObject[] json = new JSONObject[urls.length];
			    		for (int i = 0; i < urls.length; i++) {
			    			HttpGet httpGet = new HttpGet(urls[i]);
			    			
			    			try {
					        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
					        	HttpResponse response =  client.execute(httpGet);

					        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
								StringBuilder builder = new StringBuilder();
								for (String line = null; (line = reader.readLine()) != null; ) {
								    builder.append(line).append("\n");
								}
							JSONTokener tokener = new JSONTokener(builder.toString());
							json[i] = new JSONObject(tokener);
							
					        } catch (Exception e) {
					        	Log.e(TAG,e.toString());
								e.printStackTrace();
								return null;
							}
						}
			    		return json;
			    	}
			    }

			    
			    @Override
			    protected void onPostExecute(JSONObject[] json) {
			    	
			        if(json != null) {  
			        	
			        	scheduleList.clear();
			        	System.out.println("task success");
			        	System.out.println("Schedule route json length " + json.length);
			        
			        		for (int j = 0; j < json.length ; j++) {
			        			JSONArray schedules = new JSONArray();
			        			String busStopId = null;
				        		try {
				        			schedules = json[j].getJSONArray("schedule");
								} catch (JSONException e) {
									e.printStackTrace();
								}
					        	try {
									String line = json[j].getString("busstopID");
									busStopId = line;
								} catch (JSONException e) {
									e.printStackTrace();
								}
					        	
					        	for (int i = 0; i < schedules.length(); i++) {
					        		JSONObject c = new JSONObject(); 
					        		SchedulesByBusStop schedule = new SchedulesByBusStop();
					        		
					        		schedule.setBusStopId(busStopId);
					        		
						        	try {
										c = schedules.getJSONObject(i);
									} catch (JSONException e1) {
										e1.printStackTrace();
									}
						        	try {
										String line = c.getString("line");
										schedule.setLine(line);
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	try {
										String line = c.getString("name");
										schedule.setDestination(line);
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	
						        	JSONArray departures = new JSONArray();
						        	try {
						        		departures = c.getJSONArray("departures");
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	
						        	//We only need the first departure
						        	for (int k = 0; k < 1; k++) {
						        		
						        		JSONObject d = new JSONObject(); 
							        	try {
											d = departures.getJSONObject(k);
										} catch (JSONException e1) {
											e1.printStackTrace();
										}
						        		
						        		try {
											int line = d.getInt("id");
											schedule.setTripId(line);
										} catch (JSONException e) {
											e.printStackTrace();
											break;
										}
						        		try {
											String line = d.getString("t");
											schedule.setScheduledDepartureTime(line);
										} catch (JSONException e) {
											e.printStackTrace();
										}
						        
						        		scheduleList.add(schedule);
						        	}
					        	}
			        		} 
			        	
			        		
			        	System.out.println("schedulebystoplist size = "+scheduleList.size());
			        	
//						 Point p = new Point();
//						   p.x = 100;
//						   p.y = 100;
//						
//						   int popupWidth = 300;
//						   int popupHeight = 500;
//						   
//			            // Inflate the popup_layout.xml
//			            LinearLayout viewGroup = (LinearLayout) getActivity().findViewById(R.id.popup);
//			            LayoutInflater layoutInflater = (LayoutInflater) getActivity()
//			              .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
//			            View layout = layoutInflater.inflate(R.layout.popup_route_window, viewGroup);
//			          
//			            // Creating the PopupWindow
//			            final PopupWindow popup = new PopupWindow(mContext);
//			            popup.setContentView(layout);
//			            popup.setWidth(popupWidth);
//			            popup.setHeight(popupHeight);
//			            popup.setFocusable(true);
//			          
//			            // Some offset to align the popup a bit to the right, and a bit down, relative to button's position.
//			            int OFFSET_X = 0;
//			            int OFFSET_Y = 0;
//			          
//			            // Clear the default translucent background
////			            popup.setBackgroundDrawable(new BitmapDrawable());
//			          
//			            // Displaying the popup at the specified location, + offsets.
//			            popup.showAtLocation(layout, Gravity.CENTER, p.x + OFFSET_X, p.y + OFFSET_Y);
//			               
			         
			            for (int i = 0; i < scheduleList.size(); i++) {
							System.out.println("i = " + i + " route " + scheduleList.get(i).getLine()+ " and dest " + scheduleList.get(i).getDestination());
						}
			            
//			           AlterAdapter();
//			            LinearLayout layout = (LinearLayout) getActivity().findViewById(R.id.popup);
//			            RadioGroup radioGroup = new RadioGroup(mContext);
//			            
//			            LinearLayout.LayoutParams p = new LinearLayout.LayoutParams(
//			                    LinearLayout.LayoutParams.FILL_PARENT,
//			                    LinearLayout.LayoutParams.WRAP_CONTENT 
//			            );
//			            layout.addView(radioGroup, p);
			            
			            
//			            radioGroup.removeAllViews();
			            
			            if (radioButtonsList.size()>0) {
							for (int i = 0; i < radioButtonsList.size(); i++) {
								radioGroup.removeView(radioButtonsList.get(i));
							}
						}
			            
			 
//			            textViewInfo.setVisibility(View.VISIBLE);
			            
			            List<String> lineList = new ArrayList<String>();
			           
			            for (int i = 0; i < scheduleList.size(); i++) {
			            	RadioButton radioButtonView = new RadioButton(mContext);
				            radioButtonView.setText(scheduleList.get(i).getLine());
//				            radioButtonView.setId(Integer.parseInt(scheduleList.get(i).getLine()));
				            radioButtonView.setId(i);
//				            radioButtonView.setClickable(true);
				            radioButtonView.setOnCheckedChangeListener(new OnCheckedChangeListener() {
								
				            	
				            	//When a radio button is enabled
								@Override
								public void onCheckedChanged(
										CompoundButton arg0, boolean arg1) {
									// TODO Auto-generated method stub
									if(arg1){
									
									String line = scheduleList.get(arg0.getId()).getLine();
									String dest = scheduleList.get(arg0.getId()).getDestination();
									busIdOfBusStopEnabled = scheduleList.get(arg0.getId()).getBusStopId();
									//start the progress dialog
									progressDialogPopup = ProgressDialog.show(mContext, "", "Henter kjrerute for bussrute: "+line+ " retning "+dest);	
										
									System.out.println("du har valgt " + arg0.getId());
									
									int tripId = scheduleList.get(arg0.getId()).getTripId();
									 
									Calendar cal = Calendar.getInstance();
						       	    SimpleDateFormat df2 = new SimpleDateFormat("dd.MM.yyyy");
						       	    String toDay = df2.format(cal.getTime());
						       	    System.out.println(toDay);
						       		
						       	     URI uri = null;
						       			 try {
						       					System.out.println("Kobler opp");
						       					uri = new URI("http://bartebuss.no/api/trip/"+tripId+"/"+toDay);
						       	
						       				} catch (URISyntaxException e) {
						       					// TODO Auto-generated catch block
						       					e.printStackTrace();
						       					System.out.println("could not instansiate url");
						       				}
						       			 
						       			 new TripTask().execute(uri);	

									}
								}
							});
				        
				            radioButtonsList.add(radioButtonView);
				            
				            System.out.println(scheduleList.get(i).getLine());
				            
				            if(lineList.size()>0){
				            	if(!lineList.contains(scheduleList.get(i).getLine())){
				            		 lineList.add(scheduleList.get(i).getLine());
				            		 radioGroup.addView(radioButtonView);
				            	}
				            }
				            else{
				            	 lineList.add(scheduleList.get(i).getLine());
				            	 radioGroup.addView(radioButtonView);
				            }
						}
			 
//			           textViewInfo.setVisibility(View.VISIBLE);
			           progressDialogPopup.dismiss();
			        }
			        else {
			        	System.out.println("task failed");
			        }
			    }
			}
    
    
    // An AsyncTask class
    private class BusTask extends AsyncTask<String, Void, URI>{
 
		@Override
        protected URI doInBackground(String... stop) {
 
        	URI uri = null;
        	try {
				System.out.println("Kobler opp mot BusBuddy API'et");
				System.out.println("Bus stop id = " + stop[0]);
				uri = new URI("http://bartebuss.no/api/unified/"+stop[0]);

			} catch (URISyntaxException e) {
				e.printStackTrace();
				System.out.println("could not instansiate url");
			}

            return uri;
        }
 
        
        @Override
        protected void onPostExecute(URI uri) {

        	 new ScheduleRoutesTask().execute(uri); 
        }
    }
    
    
    
    /******************
     * Async class to recieve schedules for bus stops based on id
    **************************************************************** */
			public class ScheduleTimeTask extends AsyncTask<URI, Void, JSONObject[] > {
				private static final String TAG = "HTTP_TASK";
	

			    @Override
			    protected JSONObject[] doInBackground(URI...urls) {
			    	// Performed on Background Thread

			    	HttpClient client = new DefaultHttpClient();
			    	
			    	if(urls.length==1){
					HttpGet httpGet = new HttpGet(urls[0]);
			    	
			        try {
			        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
			        	HttpResponse response =  client.execute(httpGet);

			        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
						StringBuilder builder = new StringBuilder();
						for (String line = null; (line = reader.readLine()) != null; ) {
						    builder.append(line).append("\n");
						}
						JSONTokener tokener = new JSONTokener(builder.toString());
						JSONObject[] json = new JSONObject[1];
						json[0] = new JSONObject(tokener);
						return json;

			        } catch (Exception e) {
			        	Log.e(TAG,e.toString());
						e.printStackTrace();
						return null;
					}
			    	}
			    	
			    	else{
			    
			    		JSONObject[] json = new JSONObject[urls.length];
			    		for (int i = 0; i < urls.length; i++) {
			    			HttpGet httpGet = new HttpGet(urls[i]);
			    			
			    			try {
					        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
					        	HttpResponse response =  client.execute(httpGet);

					        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
								StringBuilder builder = new StringBuilder();
								for (String line = null; (line = reader.readLine()) != null; ) {
								    builder.append(line).append("\n");
								}
							JSONTokener tokener = new JSONTokener(builder.toString());
							json[i] = new JSONObject(tokener);
							
					        } catch (Exception e) {
					        	Log.e(TAG,e.toString());
								e.printStackTrace();
								return null;
							}
						}
			    		return json;
			    	}
			    }

			    
			    @Override
			    protected void onPostExecute(JSONObject[] json) {
			    	
			    	// Done on UI Thread
			        if(json != null) {  
			        	
			        	System.out.println("task success");
			        	System.out.println("Schedule json length " + json.length);
			        
			        		for (int j = 0; j < json.length ; j++) {
			        			JSONArray schedules = new JSONArray();
			        			String busStopId = null;
				        		try {
				        			schedules = json[j].getJSONArray("schedule");
								} catch (JSONException e) {
									e.printStackTrace();
								}
					        	try {
									String line = json[j].getString("busstopID");
									busStopId = line;
								} catch (JSONException e) {
									e.printStackTrace();
								}
					        	
					        	for (int i = 0; i < schedules.length(); i++) {
					        		JSONObject c = new JSONObject(); 
					        		SchedulesByBusStop schedule = new SchedulesByBusStop();
					        		
					        		schedule.setBusStopId(busStopId);
					        		
						        	try {
										c = schedules.getJSONObject(i);
									} catch (JSONException e1) {
										e1.printStackTrace();
									}
						        	try {
										String line = c.getString("line");
										schedule.setLine(line);
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	try {
										String line = c.getString("name");
										schedule.setDestination(line);
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	
						        	JSONArray departures = new JSONArray();
						        	try {
						        		departures = c.getJSONArray("departures");
									} catch (JSONException e) {
										e.printStackTrace();
									}
						        	
						        
						        	//We only need the first departure
						        	for (int k = 0; k < 1; k++) {
						        		
						        		JSONObject d = new JSONObject(); 
							        	try {
											d = departures.getJSONObject(k);
										} catch (JSONException e1) {
											e1.printStackTrace();
										}
						        		
						        		try {
											int line = d.getInt("id");
											schedule.setTripId(line);
										} catch (JSONException e) {
											e.printStackTrace();
											break;
										}
						        		try {
											String line = d.getString("t");
											schedule.setScheduledDepartureTime(line);
										} catch (JSONException e) {
											e.printStackTrace();
										}
						        
						        		scheduleList.add(schedule);
						        		
							       		 Calendar cal = Calendar.getInstance();
							       	     SimpleDateFormat df2 = new SimpleDateFormat("dd.MM.yyyy");
							       	     String toDay = df2.format(cal.getTime());
							       	     System.out.println(toDay);
							       		
							       	     URI uri = null;
							       			 try {
							       					System.out.println("Kobler opp");
							       					uri = new URI("http://bartebuss.no/api/trip/"+schedule.getTripId()+"/"+toDay);
							       	
							       				} catch (URISyntaxException e) {
							       					// TODO Auto-generated catch block
							       					e.printStackTrace();
							       					System.out.println("could not instansiate url");
							       				}

							       			 new TripTask().execute(uri);	
						        	}
						        	
					        	}
			        		} 
			        	
			        		
			        	System.out.println("schedulebystoplist size = "+scheduleList.size());
//			        	getTrips();
			        }
			        else {
			        	System.out.println("task failed");
			        }
			    }
			}
			
			
			
			 /******************
		     * Async class to receive trips for bus schedules
		    **************************************************************** */
					public class TripTask extends AsyncTask<URI, Void, JSONObject[] > {
						private static final String TAG = "HTTP_TASK";
						
					    @Override
					    protected JSONObject[] doInBackground(URI...urls) {
					    	
					    	HttpClient client = new DefaultHttpClient();
					    	
					    	if(urls.length==1){
							HttpGet httpGet = new HttpGet(urls[0]);
					    	
					        try {
					        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
					        	HttpResponse response =  client.execute(httpGet);

					        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
								StringBuilder builder = new StringBuilder();
								for (String line = null; (line = reader.readLine()) != null; ) {
								    builder.append(line).append("\n");
								}
								JSONTokener tokener = new JSONTokener(builder.toString());
								JSONObject[] json = new JSONObject[1];
								json[0] = new JSONObject(tokener);
								return json;

					        } catch (Exception e) {
						// TODO handle different exception cases
					        	Log.e(TAG,e.toString());
								e.printStackTrace();
								return null;
							}
					    	}
					    	
					    	else{
					    
					    		JSONObject[] json = new JSONObject[urls.length];
					    		for (int i = 0; i < urls.length; i++) {
					    			HttpGet httpGet = new HttpGet(urls[i]);
					    			
					    			try {
							        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
							        	HttpResponse response =  client.execute(httpGet);

							        	// TODO handle bad response codes (such as 404, etc)
							        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
										StringBuilder builder = new StringBuilder();
										for (String line = null; (line = reader.readLine()) != null; ) {
										    builder.append(line).append("\n");
										}
									JSONTokener tokener = new JSONTokener(builder.toString());
									json[i] = new JSONObject(tokener);
									
							        } catch (Exception e) {
								// TODO handle different exception cases
							        	Log.e(TAG,e.toString());
										e.printStackTrace();
										return null;
									}
								}
					    		return json;
					    	}
					    }

					    
					    @Override
					    protected void onPostExecute(JSONObject[] json) {
					    	
					    	// Done on UI Thread
					        if(json != null) {  
					        	
					        	if(stopsList.size()>0){
					        	stopsList.clear();
					        	}
					        	if(busIconDrawn){
					        		busIcon.remove();
					        		busIconDrawn = false;
					        	}

					        	System.out.println("task success");
					        	System.out.println("Trip task json length " + json.length);
					        
//					        	List<Stops> stopsList = new ArrayList<Stops>();
					        	
					        		for (int j = 0; j < json.length ; j++) {
					        			
//					        			String startId = schedulesByStopListFromDest.get(j).getBusStopId();
//					        			String depTime = schedulesByStopListFromDest.get(j).getScheduledDepartureTime();
					        			JSONArray stops = new JSONArray();
					        		
					        			String lineNr = null;
					        			Trip trip = new Trip();
					        			
						        		try {
						        			stops = json[j].getJSONArray("stops");
										} catch (JSONException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
						        		try {
						        			lineNr = json[j].getString("line");
						        			trip.setLine(lineNr);
										} catch (JSONException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
						        		try {
						        			String line = json[j].getString("tripID");
						        			trip.setTripID(line);
										} catch (JSONException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
							        
							        	for (int i = 0; i < stops.length(); i++) {
							        		JSONObject c = new JSONObject(); 
							        		Stops stop = new Stops();
							        		
							        		stop.setLine(lineNr);
							        	
//							        		stop.setStartBusStopId(startId);
//							        		stop.setDepartureTimeFromStart(depTime);
								        	try {
												c = stops.getJSONObject(i);
											} catch (JSONException e1) {
												// TODO Auto-generated catch block
												e1.printStackTrace();
											}
								        	try {
												String line = c.getString("busstopID");
												stop.setBusstopID(line);
												
//												//If it's one of the end stops break, as we don't need to gather more stops
//												if(db.getDistanceObjectByLocID(line)!=null){
//													break;
//												}
//												System.out.println(line);
											} catch (JSONException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
								        	try {
												String line = c.getString("time");
												stop.setTime(line);
//												System.out.println(line);
											} catch (JSONException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
								        	try {
												String line = c.getString("destination");
												stop.setDestination(line);
//												System.out.println(line);
											} catch (JSONException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
								        	
								        	stopsList.add(stop);
								        	
								        }	
//							        	new GeocoderDistanceTask().execute(trip);
//							        	new DownloadBusStopParserTask().execute(trip);
							        } 
					        		System.out.println("stoplist size "+stopsList.size());
					        		
					        		//Only remove old polyLines from map
					        		if (polyLineList.size()>0) {
										for (int j = 0; j < polyLineList.size(); j++) {
					
											 polyLineList.get(j).remove();
											
										}
										polyLineList.clear();
										polylineList.clear();
										polyLineOptionsList.clear();
									}
					        		
					        		List<String> name = db.getBusStopNameById(busIdOfBusStopEnabled);
					        		//Set busIcon at the first bus stop
					        		if(stopsList.size()>0){
					        	
					        			 busIcon = mMap.addMarker(new MarkerOptions()
					 			        .position(db.getBusStopLocById(busIdOfBusStopEnabled))
					 			        .title("Ta buss nr: " + stopsList.get(0).getLine()+ " herifra")
					 			        .snippet("busstopp: " +name.get(0).toString())
					 			        .anchor((float) 0.5, (float)0.5)
					 			        .icon(BitmapDescriptorFactory.fromResource(R.drawable.bus)));
					        			 
					        			 busIconDrawn = true;
					        		}
					  
					        		new DrawFinalBusRouteTask().execute("start");

					        }else {
					        	System.out.println("task failed");
					        }
					    }    
				}
					
					
					
					 // An AsyncTask class for accessing the GeoCoding Web Service
				    private class GeocoderDistanceTask extends AsyncTask<Trip, Void, String>{
				 
						@Override
				        protected String doInBackground(Trip... trips) {
				            
				        	Trip trip = trips[0];
				        	List<Stops> stops = trip.getStops();
				        	LatLng from = db.getBusStopLocById(stops.get(0).getBusstopID());
				        	LatLng to = db.getBusStopLocById(stops.get(1).getBusstopID());
				        	
				        	GeoDistance getDistance = new GeoDistance();
				        	String distance = getDistance.GetRoutDistane(from.latitude, from.longitude, to.latitude, to.longitude, "walking");
				        	
				            return distance;
				        }
				 
				        
				        @Override
				        protected void onPostExecute(String distance) {
//				        	setDistance(distance);
				        	System.out.println(distance);
				            distances.add(distance);
				            
				        }
				    }		
				    
				    
				    // An AsyncTask class
				    private class BusAnimationTask extends AsyncTask<Trip, Void, String>{
				 
						@Override
				        protected String doInBackground(Trip... trips) {
				            
							
							List<Stops> stops = trips[0].getStops();
				        	
							for (int i = 0; i < stops.size(); i++) {
								if (TimeIsPassed(stops.get(i).getTime())) {
									
								}
							}
				        	
				            return "finished";
				        }
				 
				        
				        @Override
				        protected void onPostExecute(String distance) {
//				        	setDistance(distance);
				        	System.out.println(distance);
				            distances.add(distance);
				            
				        }
				    }


					public String getTimeNow() {
						return timeNow;
					}

					public void setTimeNow(String timeNow) {
						this.timeNow = timeNow;
					}

					public void setTodaysDate(String todaysDate) {
						this.todaysDate = todaysDate;
					}
					
		
				    
				    
				    /******************
				     * Async class to receive trips for det chosen best possible route
				    **************************************************************** */
							public class DrawFinalBusRouteTask extends AsyncTask<String, Void, String> {
								
							    @Override
							    protected String doInBackground(String...routes) {
						
									 for (int k = 0; k < stopsList.size()-1; k++) {

										 if(stopsList.get(k).getBusstopID().equals(busIdOfBusStopEnabled)){
											 for (int j = k; j <  stopsList.size()-1; j++) {
												 
												 System.out
														.println(stopsList.get(j).getBusstopID());
												 
												 LatLng from = db.getBusStopLocById(stopsList.get(j).getBusstopID());
												 LatLng to = db.getBusStopLocById(stopsList.get(j+1).getBusstopID());
													
												 System.out
														.println("from " + from + " to " +to);
												 
													if(from != null && to!=null){
												
													String url = getDirectionsUrl(from, to, "driving");

													getBusStopRoutePolylines(url);
													}
											}
											
										 }
//										 return "finished";		
										}
									 return "finished";
							    }

							    
							    @Override
							    protected void onPostExecute(String string) {
							    	
							    	if(string.equals("finished")){
				    				// Drawing polyline in the Google Map for the i-th route
				    				for (int i = 0; i < polyLineOptionsList.size(); i++) {
				    					polyLineList.add(mMap.addPolyline(polyLineOptionsList.get(i)));
				    				}
				    				System.out.println("polylines drawn upon map");
							    	}
							    	 progressDialogPopup.dismiss();
							    }
						 }

  
				    
					
}
