package com.mso.master;

import org.apache.http.impl.conn.tsccm.WaitingThreadAborter;

public class PossibleRoute {

	private String startBusStopId;
	private String endBusStopId;
	private String line;
	private int tripId;
	private double weight;
	private String departureBusTime;
	private double w1;
	private double w2;
	private double w3;
	private double wait_time;
	private double total_time;
	private String destinationTimeAtBusStop;
	
	private final double WEIGHT_VARIABLE_DT1 = 0.1;
	private final double WEIGHT_VARIABLE_WT = 0.4;
	private final double WEIGHT_VARIABLE_BT = 0.4;
	private final double WEIGHT_VARIABLE_DT2 = 0.1;
	
	private Trip trips;

	
	public PossibleRoute(){
		
	}
	
	public String getStartBusStopId() {
		return startBusStopId;
	}
	public void setStartBusStopId(String startBusStopId) {
		this.startBusStopId = startBusStopId;
	}
	public String getEndBusStopId() {
		return endBusStopId;
	}
	public void setEndBusStopId(String endBusStopId) {
		this.endBusStopId = endBusStopId;
	}
	public String getLine() {
		return line;
	}
	public void setLine(String line) {
		this.line = line;
	}
	
	@Override
	public String toString(){
		return "from " + getStartBusStopId() + " to " + getEndBusStopId() + " with line " + getLine();
	}

	public double getWeight() {
		return weight;
	}

	public void setWeight(double weight) {
		this.weight = weight;
	}

	public double getW1() {
		return w1;
	}

	public void setW1(double w1) {
		this.w1 = w1;
	}

	public double getW2() {
		return w2;
	}

	public void setW2(double w2) {
		this.w2 = w2;
	}

	public double getW3() {
		return w3;
	}

	public void setW3(double w3) {
		this.w3 = w3;
	}
	
	
//	public void computeWeightValue(){
//		
//		double sum = w1+w2+w3;
//		double weight = (w1*(w1/sum)) + (WEIGHT_VARIABLE*(w2*(w2/sum))) + (w3*(w3/sum));
//		setWeight(weight);
//	}
	
	public void computeWeightValue(){
		
//		double sum = w1+w2+w3;
		double weight = (w1*WEIGHT_VARIABLE_DT1) + (wait_time*WEIGHT_VARIABLE_WT) + (w2*WEIGHT_VARIABLE_BT) + (w3*WEIGHT_VARIABLE_DT2);
		setWeight(weight);
	}

	public int getTripId() {
		return tripId;
	}

	public void setTripId(int tripId) {
		this.tripId = tripId;
	}

	public String getDepartureBusTime() {
		return departureBusTime;
	}

	public void setDepartureBusTime(String departureBusTime) {
		this.departureBusTime = departureBusTime;
	}

	public Trip getTrips() {
		return trips;
	}

	public void setTrips(Trip trips) {
		this.trips = trips;
	}

	public double getWait_time() {
		return wait_time;
	}

	public void setWait_time(double wait_time) {
		this.wait_time = wait_time;
	}

	public double getTotal_time() {
		return total_time;
	}

	public void setTotal_time(double total_time) {
		this.total_time = total_time;
	}
	
	public void computeTotalTime(){
		double sum = w1 + w2 + w3 + wait_time;
		setTotal_time(sum);
	}

	public String getDestinationTimeAtBusStop() {
		return destinationTimeAtBusStop;
	}

	public void setDestinationTimeAtBusStop(String destinationTimeAtBusStop) {
		this.destinationTimeAtBusStop = destinationTimeAtBusStop;
	}
}
