package com.mso.master;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import android.graphics.PorterDuff;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polyline;
import com.squareup.otto.Subscribe;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.ListFragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.graphics.Color;
import android.nfc.Tag;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.InflateException;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.MultiAutoCompleteTextView;
import android.widget.TextView;





@SuppressLint("ValidFragment")
public class RealTimeFragment extends Fragment{

	
	private List<BusStop> busStopList;
	private List<String> busStopNames;
	private List<BusStop> reducedBusStopList;
	ArrayList<String> partialNames;
	private FragmentManager myFragmentManager;
	private MapFragment myMapFragment;
	private GoogleMap mMap;
	
	private Context mContext;

	private MainActivity activity;
	private Marker locationIcon;
	private boolean locationChanged = false;
	
	private double lat = 0.0;
	private double lon = 0.0;
//	private static View view;
	private int mProgressStatus;

	private MultiAutoCompleteTextView autoTextView;
	private ListView listView;
	private Button mapButton;
	private TextView searchTextView;
	private TextView closeTextView;
	
	private TextView textView;
	private Button closeButton;

	private boolean busStopDrawn = false;
	private View view;
	private LatLng fromDestinationCoordinate;
	private LatLng toDestinationCoordinate;
	private Tag tag; 
	ArrayAdapter<String> adapter;
	private LatLng mPosition;
	private DBaccess db;
	private String chosenBusStop;
	
	ProgressDialog progressDialog = null;
	
	public RealTimeFragment(){
		
	}
	
	public RealTimeFragment(Context con, List<BusStop> busstops, List<String> names){
		this.mContext = con;
//		this.db = new DBaccess(con);
//		this.progressDialog = new ProgressDialog(mContext);	
	//	this.mProgressbarAsync = new ProgressBarAsync();
		this.busStopList = busstops;
		this.busStopNames = names;
		
		reducedBusStopList = new ArrayList<BusStop>();
		db = new DBaccess(con);
	}
	
	
	@Override 
	public void onResume() {
	    super.onResume();
	    LocationChangedHandler.getInstance().register(this);
	  }

	 @Override 
	 public void onPause() {
	    super.onPause();
	    LocationChangedHandler.getInstance().unregister(this);
	  }
	
	
		@Override
		 public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			// Inflate the layout for this fragment
//			  View view = inflater.inflate(R.layout.realtimefragment, container, false);
	  
			//Gets the underlying view and saves its state 
			//when moving between Fragment the map is still intact and not changed
			    if (view != null) {
			        ViewGroup parent = (ViewGroup) view.getParent();
			        if (parent != null)
			            parent.removeView(view);
			    }
			    try {
			        view = inflater.inflate(R.layout.realtime_fragment, container, false);
			    } catch (InflateException e) {
			        /* map is already there, just return view as it is */
			    }
			    
			    view.setBackgroundColor(getResources().getColor(R.color.black));
			    
//			    String[] values = new String[] { "Android", "iPhone", "WindowsMobile",
//			            "Blackberry", "WebOS", "Ubuntu", "Windows7", "Max OS X",
//			            "Linux", "OS/2" };
//			    ArrayAdapter<String> adapter = new ArrayAdapter<String>(mContext, android.R.layout.simple_list_item_1, values);
//			    setListAdapter(adapter);
//			    
			    busStopNames = db.getAllBusStopNames();
			    busStopNames = removeDuplicates(busStopNames);
			    
			    searchTextView = (TextView) view.findViewById(R.id.search_text);
//		        fromToText.setBackgroundColor(getResources().getColor(R.color.white));
			    searchTextView.setTextColor(getResources().getColor(R.color.white));
			    
			    closeTextView = (TextView) view.findViewById(R.id.close_text);
		        closeTextView.setTextColor(getResources().getColor(R.color.white));
			    
				
				String[] names = new String[busStopNames.size()];
				busStopNames.toArray(names);
			    partialNames = new ArrayList<String>();
				
			    listView = (ListView) view.findViewById(R.id.list);
				adapter = new ArrayAdapter<String>(mContext, android.R.layout.simple_list_item_1, partialNames);
			        listView.setAdapter(adapter);
			        
			       
			        
			    autoTextView = (MultiAutoCompleteTextView) view.findViewById(R.id.multiAutoCompleteTextView);
			    autoTextView.setBackground(getResources().getDrawable(R.drawable.frame));
				
			        
			    AlterAdapter();  
			    
			    listView.setOnItemClickListener(new OnItemClickListener() {

					@Override
					public void onItemClick(AdapterView<?> arg0, View arg1,
							int arg2, long arg3) {
						// TODO Auto-generated method stub
						
						hideKeyboard();
						
						String busStopname = listView.getAdapter().getItem(arg2).toString();
						setChosenBusStop(busStopname);
						List<String> id = db.getBusStopIDbyName(busStopname);
						System.out.println(id.toString());
						String[] idArray = new String[id.size()];
						id.toArray(idArray);
						
						new FragmentExecuter().execute(idArray);
					}
				});
//			      
//			    autoTextView.setAdapter(
//				          new ArrayAdapter<String>(mContext, 
//				            android.R.layout.simple_dropdown_item_1line, names));
//				autoTextView.setTokenizer(
//				          new MultiAutoCompleteTextView.CommaTokenizer());
//				
				autoTextView.setOnEditorActionListener(new TextView.OnEditorActionListener() {
					
					@Override
						public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
						
			                if (actionId == EditorInfo.IME_ACTION_SEARCH) {
			                	performSearch();
			                    return true;
			                }
			                return false;
			            }

			        	//When pressing search button on keyboard
						private void performSearch() {
							hideKeyboard();		
						}
					});
				
				autoTextView.addTextChangedListener(new TextWatcher() {

			            // As the user types in the search field, the list is
			            @Override
			            public void onTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
			                AlterAdapter();
			            }

			            // Not used for this program
			            @Override
			            public void afterTextChanged(Editable arg0) {

			            }

			            // Not uses for this program
			            @Override
			            public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
			                // TODO Auto-generated method stub

			            }
			        });
				
				
				
				closeButton = (Button) view.findViewById(R.id.closeby_button);
//				closeButton.getBackground().setColorFilter(Color.WHITE,PorterDuff.Mode.LIGHTEN);
//				closeButton.setBackgroundColor(getResources().getColor(R.color.white));
//				closeButton.setBackgroundResource(getResources().getColor(R.color.white));
				closeButton.setTextColor(getResources().getColor(R.color.white));
				closeButton.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						
//						//start the progress dialog
//						progressDialog = ProgressDialog.show(mContext, "", "Laster inn busstopper nr deg...", true);
//					
						new FragmentExecuter().execute("close");
					}
				});
				
				
				mapButton = (Button) view.findViewById(R.id.mapsearch_button);
//				mapButton.setBackgroundColor(getResources().getColor(R.color.white));
				mapButton.setTextColor(getResources().getColor(R.color.white));
				mapButton.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
//						
//						//start the progress dialog
//						progressDialog = ProgressDialog.show(mContext, "", "Laster inn kartet...", true);
//						
						new FragmentExecuter().execute("map");
					}
				});
				

				
				
				URI uri = null;
				try {
					uri = new URI("http://api.busbuddy.no/api/1.4.4/departures/16010333?apiKey=1x1ysRk94OTFa6zwvxMo");
				} catch (URISyntaxException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println("could not instansiate url");
				}

				
//				new HttpTask().execute(uri);
				
				
				
			return view;   
		    }
		
    
		@Subscribe public void onLocationChanged(LocationChangedEvent event) {
				 LatLng coordinate = new LatLng(event.lat, event.lon);
				 setMyPosition(coordinate);
		}  
		
		private void hideKeyboard (){
			InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.hideSoftInputFromWindow(autoTextView.getWindowToken(), 0);
		}
		
		
		 // Filters list of contacts based on user search criteria. If no information is filled in, contact list will be blank.
	    private void AlterAdapter() {
	        if (autoTextView.getText().toString().isEmpty()) {
	            partialNames.clear();
	            adapter.notifyDataSetChanged();
	        }
	        else {
	            partialNames.clear();
	            for (int i = 0; i < busStopNames.size(); i++) {
	                if (busStopNames.get(i).toString().toUpperCase().contains(autoTextView.getText().toString().toUpperCase())) {
	                    partialNames.add(busStopNames.get(i).toString());
	                }
	                adapter.notifyDataSetChanged();
	            }
	        }
	    }
	    
	        
		public List<String> removeDuplicates (List<String> stops){
			List<String> res = new ArrayList<String>();
			for (int i = 0; i < busStopNames.size()-1; i++) {
				if(!busStopNames.get(i).equals(busStopNames.get(i+1))){
					res.add(busStopNames.get(i));
				}
				if(i==busStopNames.size()-2){
					res.add(busStopNames.get(i));
				}
			}
			
			return res;
		}
	    
	    
		public LatLng getFromDestinationCoordinate() {
			return fromDestinationCoordinate;
		}

		public void setFromDestinationCoordinate(LatLng fromDestinationCoordinate) {
			this.fromDestinationCoordinate = fromDestinationCoordinate;
		}

		public LatLng getToDestinationCoordinate() {
			return toDestinationCoordinate;
		}

		public void setToDestinationCoordinate(LatLng toDestinationCoordinate) {
			this.toDestinationCoordinate = toDestinationCoordinate;
		}
		
		public LatLng getMyPosition (){
			return mPosition;
		}
		
		public void setMyPosition (LatLng pos){
			this.mPosition = pos;
		}
		
		public void setChosenBusStop(String name){
			this.chosenBusStop = name;
		}
		
		public String getChosenBusStop(){
			return chosenBusStop;
		}
		
			private class ProgressBarAsync extends AsyncTask<Void, Integer, Void>{
			
				/** This callback method is invoked, before starting the background process */
		        @Override
		            protected void onPreExecute() {
		            super.onPreExecute();
		            mProgressStatus = 0;
		        }
		 
		        /** This callback method is invoked on calling execute() method
		        * on an instance of this class */
		        @Override
		        protected Void doInBackground(Void...params) {
		            while(mProgressStatus<100){
		                try{
		 
		                    mProgressStatus++;
		 
		                    /** Invokes the callback method onProgressUpdate */
		                    publishProgress(mProgressStatus);
//		 
		                    /** Sleeps this thread for 100ms */
		                    Thread.sleep(100);
		                    
		        	
		                }catch(Exception e){
		                    Log.d("Exception", e.toString());
		                }
		            }
		            return null;
		        }
		 
		        /** This callback method is invoked when publishProgress()
		        * method is called */
		        @Override
		        protected void onProgressUpdate(Integer... values) {
		            super.onProgressUpdate(values);
//		            progressDialog.setProgress(mProgressStatus);
		        }
		 
		        /** This callback method is invoked when the background function
		        * doInBackground() is executed completely */
		        @Override
		        protected void onPostExecute(Void result) {
		            super.onPostExecute(result);
		            progressDialog.dismiss();
		        }
		    }


	
			
			
			public class HttpTask extends AsyncTask<URI, Void, JSONObject > {
				private static final String TAG = "HTTP_TASK";
				
				HttpTaskHandler taskHandler;

			    @Override
			    protected JSONObject doInBackground(URI...urls) {
			    	// Performed on Background Thread

			    	HttpClient client = new DefaultHttpClient();
					HttpGet httpGet = new HttpGet(urls[0]);
			    	
//			    	HttpUriRequest request = params[0];
//			    	HttpClient client = new DefaultHttpClient();

			        try {
			        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
			        	HttpResponse response =  client.execute(httpGet);

			// TODO handle bad response codes (such as 404, etc)

			        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
						StringBuilder builder = new StringBuilder();
						for (String line = null; (line = reader.readLine()) != null; ) {
						    builder.append(line).append("\n");
						}
					JSONTokener tokener = new JSONTokener(builder.toString());
					JSONObject json = new JSONObject(tokener);
					return json;

			        } catch (Exception e) {
				// TODO handle different exception cases
			        	Log.e(TAG,e.toString());
						e.printStackTrace();
						return null;
					}
			    }

			    
			    @Override
			    protected void onPostExecute(JSONObject json) {
			    	
			    	// Done on UI Thread
			        if(json != null) {    
			        	System.out.println("task success");
			        	System.out.println(json.toString());
			        	
			        	JSONArray departures = null;
			        	try {
							departures = json.getJSONArray("departures");
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			        	
			        	for (int i = 0; i < departures.length(); i++) {
							JSONObject c = null;
							try {
								c = departures.getJSONObject(i);
							} catch (JSONException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							
							try {
								String line = c.getString("line");
								System.out.println(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
			        	
			        	
//			        	taskHandler.taskSuccessful(json);
			        } else {
			        	System.out.println("task failed");
//			        	taskHandler.taskFailed();
			        }
			    }

			
			    public void setTaskHandler(HttpTaskHandler taskHandler) {
	        		this.taskHandler = taskHandler;
			    }
		}
		
			
			public static interface HttpTaskHandler {
		        void taskSuccessful(JSONObject json);
		        void taskFailed();
		    }
			
	
		
		 // An AsyncTask class for accessing ..
		    private class FragmentExecuter extends AsyncTask<String, Void, String>{
		    	
		    	ProgressDialog mProgressDialog = new ProgressDialog(mContext);
		    	
		    	
		    	 @Override
		         protected void onPreExecute() {
		    		 
		    		 
		             mProgressDialog.setTitle("");
		             mProgressDialog.setMessage("Laster inn...");
		             mProgressDialog.show();
		         }
		    	
		    	
		    	@Override
				protected String doInBackground(String... fragment) {
		        	
	
		    		if(fragment[0].equals("close")){
						// Create new close bus stop fragment and transaction
						Fragment newFragment = new CloseBusStopFragment(mContext, busStopList, getMyPosition());
						android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
						transaction.setCustomAnimations(android.R.animator.fade_in,
		                        android.R.animator.fade_out);

						// Replace whatever is in the fragment_container view with this fragment,
						// and add the transaction to the back stack
						transaction.replace(R.id.fragment_container, newFragment);
						transaction.addToBackStack(null);
						
						if(newFragment.isHidden()){
							transaction.show(newFragment);
						}
							// Commit the transaction
							transaction.commit();
							
							return "finished";
					}
		        	
		    		else if (fragment[0].equals("map")){
		    			// Create new bus stop map fragment and transaction
						MapFragment newFragment = new BusStopOnMapFragment(mContext, busStopList, getMyPosition());
//						MapFragment newFragment = new JourneyMapFragment(mContext, getMyPosition(), getMyPosition());
						android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
						transaction.setCustomAnimations(android.R.animator.fade_in,
		                        android.R.animator.fade_out);

						// Replace whatever is in the fragment_container view with this fragment,
						// and add the transaction to the back stack
						transaction.replace(R.id.fragment_container, newFragment);
						transaction.addToBackStack(null);
						
						if(newFragment.isHidden()){
							transaction.show(newFragment);
						}
							// Commit the transaction
							transaction.commit();
							
							return "finished";
		    		}
		    		else{
		    			// Create new bus stop map fragment and transaction
						Fragment newFragment = new RealtimeByStopFragment(mContext, fragment, getChosenBusStop());
						android.app.FragmentTransaction transaction = getFragmentManager().beginTransaction();
						transaction.setCustomAnimations(android.R.animator.fade_in,
		                        android.R.animator.fade_out);

						// Replace whatever is in the fragment_container view with this fragment,
						// and add the transaction to the back stack
						transaction.replace(R.id.fragment_container, newFragment);
						transaction.addToBackStack(null);
						
						if(newFragment.isHidden()){
							transaction.show(newFragment);
						}
							// Commit the transaction
							transaction.commit();
							
							return "finished";
		    		}
		    		
		    	
		        }
		        
		      
		    	@Override
		        protected void onPostExecute(String prog) {
		    		mProgressDialog.dismiss();
		        }

			
		    }
	
			
			
}

