package com.mso.master;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import com.google.android.gms.maps.MapFragment;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.TextView;




@SuppressLint("ValidFragment")
public class RealtimeByStopFragment extends Fragment {

	
	private Context mContext;
	private View v;
	private ListView listView;
	private ListView listView2;
	private TextView textView;
	private TextView textView2;
	private TextView textView_busstopname;
	private ArrayList<RealtimeByBusStop> realtimeList;
	private String busStopId;
	private String[] busStopIdArray;
	private ProgressDialog progressDialog;
	private String busStop;
	
	
	public RealtimeByStopFragment (Context con, String[] id, String stop){
		this.mContext = con;
		this.busStopIdArray = id;
		this.busStop = stop;
	
		realtimeList = new ArrayList<RealtimeByBusStop>();
	}

	
	@Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        // Inflate the layout for this fragment
//        View v = inflater.inflate(R.layout.plannerfragment, container, false);
//  
//        v.setBackgroundColor(getResources().getColor(R.color.black));
//        
      //Gets the underlying view and saves its state 
		//when moving between Fragment the map is still intact and not changed
	    if (v != null) {
	        ViewGroup parent = (ViewGroup) v.getParent();
	        if (parent != null)
	            parent.removeView(v);

	    }
	    try {
	        v = inflater.inflate(R.layout.realtimebystop_fragment, container, false);
	    } catch (InflateException e) {
	        /* map is already there, just return view as it is */
	    }
	    v.setBackgroundColor(getResources().getColor(R.color.black));
        
	  //start the progress dialog
		progressDialog = ProgressDialog.show(mContext, "", "Laster inn sanntidsdata...");
	    
	    textView = (TextView) v.findViewById(R.id.textView1_realtime);
	    textView.setTextColor(getResources().getColor(R.color.white));
	    
	    textView2 = (TextView) v.findViewById(R.id.textView2_realtime);
	    textView2.setTextColor(getResources().getColor(R.color.white));
	    
	    textView_busstopname = (TextView) v.findViewById(R.id.texView_busStopName);
	    textView_busstopname.setTextColor(getResources().getColor(R.color.white));
	    textView_busstopname.setText(busStop);
	    
	    listView = (ListView) v.findViewById(R.id.listview_realtimebystop); 
	   	listView2 = (ListView) v.findViewById(R.id.listView2_realtimebystop);
			
	    
	    AlterAdapter();   
	    
	    
	    return v;
	}
	
	
	
	@Override 
	public void onResume() {
	    super.onResume();
	   // BusProvider.getInstance().register(this);
	  }

	 @Override 
	 public void onPause() {
	    super.onPause();
	   // BusProvider.getInstance().unregister(this);
	 }  
	
	 
	 // Filters list of contacts based on user search criteria. If no information is filled in, contact list will be blank.
	    private void AlterAdapter() {

	    	
	    	
	    	List<String> id = new ArrayList<String>();
	    	Collections.addAll(id, busStopIdArray);
	    	
	    	HashSet h = new HashSet(id);
	    	id.clear();
	    	id.addAll(h);
	    	
	    	URI[] uri = new URI[id.size()];
	    	System.out.println(id.toString());
	    	
	    	for (int i = 0; i < id.size(); i++) {
						try {
							System.out.println("Kobler opp for  hente ut busstopper fra BusBuddy API'et");
							uri[i] = new URI("http://api.busbuddy.no/api/1.4.4/departures/"+id.get(i)+"?apiKey=1x1ysRk94OTFa6zwvxMo");
							System.out.println("uri array element " +uri[i]);
						} catch (URISyntaxException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
							System.out.println("could not instansiate url");
						}

	           
	        }
	    	new HttpTask().execute(uri);
	    }


	 
	    
	    public ArrayList<RealtimeByBusStop> getFromCentrumDepartures(){
	    	ArrayList<RealtimeByBusStop> list = new ArrayList<RealtimeByBusStop>();
	    	for (int i = 0; i < realtimeList.size(); i++) {
				if(!realtimeList.get(i).isGoingTowardsCentrum()){
					list.add(realtimeList.get(i));
				}
			}
	    	return list;
	    }
	    
	    public ArrayList<RealtimeByBusStop> getToCentrumDepartures(){
	    	ArrayList<RealtimeByBusStop> list = new ArrayList<RealtimeByBusStop>();
	    	for (int i = 0; i < realtimeList.size(); i++) {
				if(realtimeList.get(i).isGoingTowardsCentrum()){
					list.add(realtimeList.get(i));
				}
			}
	    	return list;
	    }
	    
	 
		//Async task to connect op Bussbuddy API to get BusStopList
		public class HttpTask extends AsyncTask<URI, Void, JSONObject[] > {
			private static final String TAG = "HTTP_TASK";
			
			HttpTaskHandler taskHandler;

		    @Override
		    protected JSONObject[] doInBackground(URI...urls) {
		    	// Performed on Background Thread

		    	HttpClient client = new DefaultHttpClient();
		    	System.out.println("urls length " +urls.length);
		    	
		    	if(urls.length==1){
				HttpGet httpGet = new HttpGet(urls[0]);
		    	
//		    	HttpUriRequest request = params[0];
//		    	HttpClient client = new DefaultHttpClient();

		        try {
		        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
		        	HttpResponse response =  client.execute(httpGet);

		// TODO handle bad response codes (such as 404, etc)

		        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
					StringBuilder builder = new StringBuilder();
					for (String line = null; (line = reader.readLine()) != null; ) {
					    builder.append(line).append("\n");
					}
					JSONTokener tokener = new JSONTokener(builder.toString());
					JSONObject[] json = new JSONObject[1];
					json[0] = new JSONObject(tokener);
					return json;

		        } catch (Exception e) {
			// TODO handle different exception cases
		        	Log.e(TAG,e.toString());
					e.printStackTrace();
					return null;
				}
		    	}
		    	
		    	else{
		    
		    		JSONObject[] json = new JSONObject[urls.length];
		    		for (int i = 0; i < urls.length; i++) {
		    			HttpGet httpGet = new HttpGet(urls[i]);
		    			
		    			try {
				        	// The UI Thread shouldn't be blocked long enough to do the reading in of the stream.
				        	HttpResponse response =  client.execute(httpGet);

				        	// TODO handle bad response codes (such as 404, etc)
				        	BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
							StringBuilder builder = new StringBuilder();
							for (String line = null; (line = reader.readLine()) != null; ) {
							    builder.append(line).append("\n");
							}
						JSONTokener tokener = new JSONTokener(builder.toString());
						json[i] = new JSONObject(tokener);
						
				        } catch (Exception e) {
					// TODO handle different exception cases
				        	System.out.println("something goes wrong...");
				        	Log.e(TAG,e.toString());
							e.printStackTrace();
							return null;
						}
					}
		    		return json;
		    	}
		    }

		    
		    @Override
		    protected void onPostExecute(JSONObject[] json) {
		    	
		    	// Done on UI Thread
		        if(json != null) {  
		        	
		        	realtimeList.clear();
		        	System.out.println("task success");
		        	System.out.println("json length " + json.length);
		        	System.out.println(json[0].toString());
		        	
		        	if(json.length == 1 ){
		        	
			        	JSONArray departures = null;
			        	boolean towardsCentrum = false;
			        	try {
			        		departures = json[0].getJSONArray("departures");
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			        	try {
			        		boolean line = json[0].getBoolean("isGoingTowardsCentrum");
			        		towardsCentrum = line;
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			        	
			        	
			        	for (int i = 0; i < departures.length(); i++) {
			        		JSONObject c = null;
				        	RealtimeByBusStop realtime = new RealtimeByBusStop();
				        	
				        	realtime.setGoingTowardsCentrum(towardsCentrum);
				        
				        	try {
								c = departures.getJSONObject(i);
							} catch (JSONException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
				        	try {
								String line = c.getString("line");
								System.out.println(line);
								realtime.setLine(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	try {
								String line = c.getString("destination");
								System.out.println(line);
								realtime.setDestination(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	try {
								String line = c.getString("registeredDepartureTime");
								System.out.println(line);
								realtime.setRegisteredDepartureTime(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	try {
								String line = c.getString("scheduledDepartureTime");
								System.out.println(line);
								realtime.setScheduledDepartureTime(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	try {
				        		boolean line = c.getBoolean("isRealtimeData");
				        		System.out.println(line);
								realtime.setRealtimeData(line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	
				        	realtimeList.add(realtime);
			        	}
			        	
			        	listView2.setVisibility(View.GONE);
			        	textView2.setVisibility(View.GONE);
			        	
			        	if(towardsCentrum){
			        		textView.setText("Til Sentrum");
			        	}
			        	
			        	CustomRealTimeAdapter adapter = new CustomRealTimeAdapter(mContext, R.layout.row_realtime, realtimeList);
//						adapter = new ArrayAdapter<DistanceBusStops>(mContext, R.layout.row, distanceList);
					        listView.setAdapter(adapter);
		     
		        } 
		        
		        	//If we got a bus stop with stops in both directions
		        	else if(json.length>1 ){
		        		
		        		boolean towardsCentrum = false;
			        	
		        		for (int j = 0; j < 2 ; j++) {
		        			
		        			JSONArray departures = new JSONArray();
		        			
			        		try {
				        		departures = json[j].getJSONArray("departures");
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	try {
								boolean line = json[j].getBoolean("isGoingTowardsCentrum");
								towardsCentrum = line;
								System.out.println("twrs centrum? "+line);
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
				        	
				        	for (int i = 0; i < departures.length(); i++) {
				        		JSONObject c = new JSONObject(); 
					        	RealtimeByBusStop realtime = new RealtimeByBusStop();
					        	try {
									c = departures.getJSONObject(i);
								} catch (JSONException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
					        	try {
									String line = c.getString("line");
									realtime.setLine(line);
								} catch (JSONException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
					        	try {
									String line = c.getString("destination");
									realtime.setDestination(line);
								} catch (JSONException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
					        	try {
									String line = c.getString("registeredDepartureTime");
									realtime.setRegisteredDepartureTime(line);
								} catch (JSONException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
					        	try {
									String line = c.getString("scheduledDepartureTime");
									realtime.setScheduledDepartureTime(line);
								} catch (JSONException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
					        	try {
									boolean line = c.getBoolean("isRealtimeData");
									realtime.setRealtimeData(line);
								} catch (JSONException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
					        	realtime.setGoingTowardsCentrum(towardsCentrum);
					        	
					        	System.out.println(realtime.toString());
					        
					        		realtimeList.add(realtime);
					        
				        	}
				        	
				        	System.out.println("J == " + j);
				        	System.out.println("realtimelist size= " +realtimeList.size());
				        	System.out.println(realtimeList.get(0).getDestination());
				        	
				        	
	//						adapter = new ArrayAdapter<DistanceBusStops>(mContext, R.layout.row, distanceList);
//						       if(j==0){
//						    	   System.out.println("setting adapter for listview 1");
//						    	   System.out.println(realtimeList.get(0).getDestination());
//						    	   CustomRealTimeAdapter1 adapter = new CustomRealTimeAdapter1(mContext, R.layout.row_realtime, realtimeList);
//						    	   listView.setAdapter(adapter);
//						    	   
//						       }
//						       else if(j==1){
//						    	   System.out.println("setting adapter for listview 2");
//						    	   CustomRealTimeAdapter1 adapter = new CustomRealTimeAdapter1(mContext, R.layout.row_realtime, realtimeList);
//						    	   System.out.println(realtimeList.get(0).getDestination());
//						    	   listView2.setAdapter(adapter);
//						       }
						       
//						       realtimeList.clear();
						       
			        	}  //end first for
		        		
		        		
		        		CustomRealTimeAdapter adapter = new CustomRealTimeAdapter(mContext, R.layout.row_realtime, getFromCentrumDepartures());
				    	   listView.setAdapter(adapter);
		        		CustomRealTimeAdapter adapter2 = new CustomRealTimeAdapter(mContext, R.layout.row_realtime, getToCentrumDepartures());
				    	   System.out.println(realtimeList.get(0).getDestination());
				    	   listView2.setAdapter(adapter2);
		        	} //end if json size is > 1
		
		        } //end if json holds values
		        
		        
		        else {
		        	System.out.println("task failed");
		        }
		        
		        progressDialog.dismiss();
		    }

		
		    public void setTaskHandler(HttpTaskHandler taskHandler) {
	    		this.taskHandler = taskHandler;
		    }
	}

		
		public static interface HttpTaskHandler {
	        void taskSuccessful(JSONObject json);
	        void taskFailed();
	    }
	 
	 
		

}
